;MonPiano par Jacobus, Dobro et Zapman 09/2004
;   PureBasic 3.91 / 3.90
;Banques de sons disponibles sur freesoundeditor.com
;
;
#TVersion = "2.3"
#DatasFolder = "MonPianoDatas"

IncludeFile ("babelresolver.pb")
;
; Creations des directory
;
If ExamineDirectory(0, #DatasFolder, "") = 0
  CreateDirectory(#DatasFolder)
EndIf
If ExamineDirectory(0, #DatasFolder+"\BANKS", "") = 0
  CreateDirectory(#DatasFolder+"\BANKS")
EndIf

#MaxNbNotes = 5000
#MaxUndo = 10
;
#WM_MOUSEWHEEL=522
; Hauteur Panels
#HPanel = 200
; Dimensions partitionneur
#PLargeur = 594
#PHauteur = 218
;
;
;-Declaration des procedures
Declare.s ApplicationDir()
Declare   Load_Sounds(Chemin$)
Declare   Enregistrer_part()
Declare   Touche(Option.l)
Declare   DecaySound (notouche.l)
Declare   DrawPartition (PStart.l)
Declare   MonPianoCallback(WindowID.l, Message.l, wParam.l, lParam.l)
Declare   Color_ButtonGadget (ID.l, x.l, y.l, w.l, h.l,Color.l, Recolor.l)
Declare   Set_Rect (x1.l,y1.l,x2.l,y2.l, *FRect.Rect)
Declare   PtInRectXtd (*FRect.Rect,x.l,y.l)
Declare   Set_DurAndPos ()
Declare   DrawTimeCursor(ShowCursor.l)
Declare   ClearSelection()
Declare   DefiniNotation()
Declare.s GiveAscFromVirtual (VKCode.l)
Declare   GiveVirtualFromStr(TouchePC$)
Declare   StopPlay ()
Declare   StopPausePlay ()
Declare   PutTextsOnButtons ()
Declare   CopyForUndo (UndoWhat$)
Declare   UndoMP()
Declare   RedoMP()
Declare   UndoTip()
Declare   RedoTip()
Declare   MakeFourCC(FourCC.s)
Declare.s FourCCToString(v.l)
Declare   Resample (*soundS,*Infos,SoundLength.l,NewnSamplesPerSec.l)
Declare   ReChannel (*soundS,*Infos,SoundLength.l,NewnChannels.w)
Declare   SaveAsWave (Result$)
Declare   SaveWindow(FSyncName$)
;
OpenLibrary(0,"DSOUND.DLL")
IncludeFile ("DirectX8Sound.pb")

;
Enumeration 
  #window = 0
EndEnumeration 
;
;- Gadgets constants
Enumeration
  #PanelGadget
  #TxSHORTCUTS
;
  #BankFrame
  #HelpFrame
  #ProjectFrame
  #PrefFrame
  #Text_Acces
  #BWebLink
  #BWebLink2
  #Text_Info
  #LIHChoice
  #Text_concept
;
  #LoadFrame
  #CBankChoice
  #LoadBar
;
  #ControlFrame
  #TPITCH
  #PITCH
  #TSRMode
  #SRMode
  #TVolBar
  #VolBar
  #TVolMBar
  #VolMBar
  #TVolFSBar
  #VolFSBar
  #TBalBar
  #BalBar
;
  #IPART
  #SBPart
;
  #Info
  #PlayR
  #PlayLoopR
  #RecordR
  #PauseR
  #StopR
  #DeleteR
  #QuantizeR
  #ZoomPlusR
  #ZoomMinusR
  #StartR
  #EndR
  #CopyR
  #CutR
  #PasteR
  #ClearR
  #SaveR
  #OpenR
  #UndoR
;
  #SyncFrame
  #TNSync
  #BOSync
;
  #MetronomeFrame
  #Metronome
  #MetroOnOff
  #MetroRythm
  #SMetroRythm
  #BPM
  #BPMPlus
  #BPMMinus
;
  #SpecFrame
  #TPos
  #SPos
  #TDur
  #SDur
  #TVol
  #SVol
  #TNote
  #CBNote
;
  #TPBkColor
  #TPRColor
  #TPLHColor
  #TPDoColor
  #TPSolColor
  #TPLVColor
  #TPNotesColor
  #TPSNotesColor
  #BPBkColor
  #BPRColor
  #BPLHColor
  #BPDoColor
  #BPSolColor
  #BPLVColor
  #BPNotesColor
  #BPSNotesColor
;
  #PrefDecay
  #TDecaySustain
  #SDecaySustain
  #TMsDecaySustain
  #TDecayRelease
  #SDecayRelease
  #TMsDecayRelease
;
  #TLanguage
  #CBLanguage
  #BLanguage
  #TNotation
  #OGDoReMi
  #OGCDE
  #OGABH
  #TKeyboard
  #TemoinTouche
  #MessageTouche
  #THKeyboard
  #BJMJarre
  #BGershwin
  #BMozart
;
  #PrefUnit
  #TRuler
  #OGRulerSec
  #OGRulerMes
  #TPosDisplay
  #OGPosms 
  #OGPosMes
  #TDurDisplay
  #OGDurms 
  #OGDurMes
  #TArrowsMoving
  #SArrowsMoving
  #OGArrms 
  #OGArrMes
  #TArrowsCtrlMoving
  #SArrowCtrlMoving
  #OGCtrlms 
  #OGCtrlMes
;
  #PrefDivers
  #ShowCursor
  #TPitchValue
  #SPitchValue
;
  #MidiFile
  #INote
  #WaveFile
  #Instrument
  #CMetronome
  #SyncFile
  #BSave
  #BCancel
EndEnumeration
;
Global MainWindow 
Global son_charge ; indique si la banque a pu tre charge
Global Volume, Pan, Frequency, Scale, NbScrollSteps
Global ReleaseDelay, SustainDelay
Global TimeCursor, PlayNow, StartGTime
Global PSDrawing, TypeNotation, ToucheB, ToucheN
;  
Volume = 0
Pan = 0
Frequency = 44100
StartGTime = -1
;
Structure Notes
  Nom.s
  CouleurTouche.s
  ToucheClavierPC.l
  Son.l
  IsPlaying.l
  MustPlay.l
  TempVolume.l
EndStructure
;
Structure NotesJouees
  Num.l
  StartTime.l
  Duration.l
  ScreenRect.Rect
  Selected.l
  WasSelected.l
  Volume.l
  UntransposedNote.l
EndStructure
;
;
Dim Notes.Notes(37)
Dim NotesJouees.NotesJouees(#MaxNbNotes)
;
Global UndoCLevel, UndoNotes, LastUndo$, MaxUndoUsed 
;
UndoNotes = AllocateMemory(SizeOf(NotesJouees)*#MaxNbNotes*#MaxUndo)
MaxUndoUsed = -1
Dim UndoName.s(#MaxUndo-1)

For ct = 0 To #MaxNbNotes
  NotesJouees(ct)\Num = -1
Next
;
;
IncludeFile ("MonPianoMidiReader.pb")
;
; catch images
Image1 = CatchImage(1, ?Image1)
ToucheB = CatchImage(8, ?ToucheB)
ToucheN = CatchImage(9, ?ToucheN)
ToucheBE = CatchImage(10, ?ToucheBE)
ToucheNE = CatchImage(11, ?ToucheNE)
Image10 = CatchImage(12, ?Image10)
Play.l = CatchImage(13, ?Play)
PlayLoop.l = CatchImage(14, ?PlayLoop)
Record.l = CatchImage(15, ?Record)
RecordOn.l = CatchImage(50, ?RecordOn)
RecordOff.l = CatchImage(51, ?RecordOff)
Pause.l = CatchImage(16, ?Pause)
Stop.l = CatchImage(17, ?Stop)
Delete.l = CatchImage(18, ?Delete)
Quantize.l = CatchImage(19, ?Quantize)
ZoomPlus.l = CatchImage(20, ?ZoomPlus)
ZoomMinus.l = CatchImage(22, ?ZoomMinus)
Start.l = CatchImage(23, ?Start)
EndR.l = CatchImage(24, ?EndR)
CopyR.l = CatchImage(30, ?CopyR)
CutR.l = CatchImage(31, ?CutR)
PasteR.l = CatchImage(32, ?PasteR)
ClearR.l = CatchImage(33, ?ClearR)
OpenR.l = CatchImage(34, ?OpenR)
SaveR.l = CatchImage(35, ?SaveR)
UndoR.l = CatchImage(36, ?UndoR)
RedoR.l = CatchImage(37, ?RedoR)
MidMetronome.l = CatchImage(100, ?MidMetronome)
L1Metronome.l = CatchImage(101, ?L1Metronome)
L2Metronome.l = CatchImage(102, ?L2Metronome)
L3Metronome.l = CatchImage(103, ?L3Metronome)
L4Metronome.l = CatchImage(104, ?L4Metronome)
R1Metronome.l = CatchImage(105, ?R1Metronome)
R2Metronome.l = CatchImage(106, ?R2Metronome)
R3Metronome.l = CatchImage(107, ?R3Metronome)
R4Metronome.l = CatchImage(108, ?R4Metronome)

DataSection 
; Data images
  Image1  : IncludeBinary "Images\About.ico"
  ToucheB : IncludeBinary "Images\blanche.BMP"
  ToucheN : IncludeBinary "Images\noire.BMP"
  ToucheBE : IncludeBinary "Images\blancheEnfoncee.BMP"
  ToucheNE : IncludeBinary "Images\noireEnfoncee.BMP"
  Image10 : IncludeBinary "Images\icon2.ico"
  Play : IncludeBinary "Images\Play.ico"
  PlayLoop : IncludeBinary "Images\PlayLoop.ico"
  Record : IncludeBinary "Images\Record.ico"
  RecordOn : IncludeBinary "Images\RecordOn.ico"
  RecordOff : IncludeBinary "Images\RecordOff.ico"
  Pause : IncludeBinary "Images\Pause.ico"
  Stop : IncludeBinary "Images\Stop.ico"
  Delete: IncludeBinary "Images\Delete.ico"
  Quantize : IncludeBinary "Images\Quantize.ico"
  ZoomPlus : IncludeBinary "Images\Zoomh+.ico"
  ZoomMinus : IncludeBinary "Images\Zoomh-.ico"
  Start : IncludeBinary "Images\Start.ico"
  EndR : IncludeBinary "Images\End.ico"
  CopyR: IncludeBinary "Images\Copy.ico"
  CutR : IncludeBinary "Images\Cut.ico"
  PasteR : IncludeBinary "Images\Paste.ico"
  ClearR : IncludeBinary "Images\ClearNOTES.ico"
  OpenR : IncludeBinary "Images\Open.ico"
  SaveR : IncludeBinary "Images\Save.ico"
  UndoR : IncludeBinary "Images\Undo.ico"
  RedoR : IncludeBinary "Images\Redo.ico"
  MidMetronome: IncludeBinary "Images\MidMetronome.bmp"
  L1Metronome: IncludeBinary "Images\L1Metronome.bmp"
  L2Metronome: IncludeBinary "Images\L2Metronome.bmp"
  L3Metronome: IncludeBinary "Images\L3Metronome.bmp"
  L4Metronome: IncludeBinary "Images\L4Metronome.bmp"
  R1Metronome: IncludeBinary "Images\R1Metronome.bmp"
  R2Metronome: IncludeBinary "Images\R2Metronome.bmp"
  R3Metronome: IncludeBinary "Images\R3Metronome.bmp"
  R4Metronome: IncludeBinary "Images\R4Metronome.bmp"
  INote  : IncludeBinary "Images\Notes.bmp"
;
; Dfinition des notes
;
Notes:
  Data$ "C1","Do_1","C1","B","#226","#226","#226" ; <> ou "\"
  Data$ "C#1","Do#_1","cis1","N","W","Z","Z"
  Data$ "D1","R_1","D1","B","X","X","X"
  Data$ "D#1","R_#1","dis1","N","C","C","C"
  Data$ "E1","Mi_1","E1","B","V","V","V"
  Data$ "F1","Fa_1","F1","B","B","B","B"
  Data$ "F#1","Fa#_1","fis1","N","N","N","N"
  Data$ "G1","Sol_1","G1","B","#188","M","M" ; ,? ou M
  Data$ "G#1","Sol#_1","gis1","N","#190","#188","#188" ; ;. ou ,
  Data$ "A2","La_1","A2","B","#191","#190","#190" ; :/ ou .
  Data$ "A#2","La#_1","B2","N","#223","191","189" ; ! ou /
  Data$ "B2","Si_1","H2","B","#16","#16","#16"
  Data$ "C2","Do_2","C2","B","Q","A","A"
  Data$ "C#2","Do#_2","cis2","N","S","S","S"
  Data$ "D2","R_2","D2","B","D","D","D"
  Data$ "D#2","R_#2","dis2","N","F","F","F"
  Data$ "E2","Mi_2","E2","B","G","G","G"
  Data$ "F2","Fa_2","F2","B","H","H","H"
  Data$ "F#2","Fa#_2","fis2","N","J","J","J"
  Data$ "G2","Sol_2","G2","B","K","K","K"
  Data$ "G#2","Sol#_2","gis2","N","L","L","L"
  Data$ "A3","La_2","A3","B","M","#186","#192" ; M ou ;
  Data$ "A#3","La#_2","B3","N","#192","#222","#222" ; % ou '
  Data$ "B3","Si_2","H3","B","Ret","Ret","Ret"
  Data$ "C3","Do_3","C3","B","A","Q","Q"
  Data$ "C#3","Do#_3","cis3","N","Z","W","W"
  Data$ "D3","R_3","D3","B","E","E","E"
  Data$ "D#3","R_#3","dis3","N","R","R","R"
  Data$ "E3","Mi_3","E3","B","T","T","T"
  Data$ "F3","Fa_3","F3","B","Y","Y","Y"
  Data$ "F#3","Fa#_3","fis3","N","U","U","U"
  Data$ "G3","Sol_3","G3","B","I","I","I"
  Data$ "G#3","Sol#_3","gis3","N","O","O","O"
  Data$ "A4","La_3","A4","B","P","P","P"
  Data$ "A#4","La#_3","B4","N","#221","#219","#186"  ; ^ P ou [
  Data$ "B4","Si_3","H4","B","#186","#221","#187" ; $ ou ]
  Data$ "C4","Do_4","C4","B","#222","#192","#220" ;  ou `
  ;
TouchesReservees :
  Data.l 8,9,17,20,27,33,34,35,36,37,38,39,40,46,91,92,93
  Data.l 112,113,114,115,116,117,118,119,120,121,122,123
  Data.l 0
  ;
EndDataSection
;
;- Lecture Fichier pref
;
Global TPBkColor, TPRColor, TPLHColor, TPDoColor, TPSolColor, TPLVColor, TPNotesColor, TPSNotesColor
Global AlwaysShowCursor, SecRuler, MRythm, msPos, msDur
Global SRMode$, txgetSounds$, txHelp1$
Global FicSync


OpenPreferences(#DatasFolder+"\MonPiano.prefs") 

TPBkColor = Val(ReadPreferenceString ("TPBkColor", "16771805"))
TPRColor = Val(ReadPreferenceString ("TPRColor", "8388736"))
TPLHColor = Val(ReadPreferenceString ("TPLHColor", "8388736"))
TPDoColor = Val(ReadPreferenceString ("TPDoColor", "255"))
TPSolColor = Val(ReadPreferenceString ("TPSolColor", "12632256"))
TPLVColor = Val(ReadPreferenceString ("TPLVColor", "16763850"))
TPNotesColor = Val(ReadPreferenceString ("TPNotesColor", "0"))
TPSNotesColor = Val(ReadPreferenceString ("TPSNotesColor", "8404992"))

ReleaseDelay = Val(ReadPreferenceString ("ReleaseDelay", "1000"))
SustainDelay = Val(ReadPreferenceString ("SustainDelay", "3000"))

AlwaysShowCursor = Val(ReadPreferenceString ("ShowCursor", "1"))
MRythm = Val(ReadPreferenceString ("BPM", "60"))
PitchVar = Val(ReadPreferenceString ("PitchVar", "100"))

SecRuler = Val(ReadPreferenceString ("SecRuler", "0"))
MsPos = Val(ReadPreferenceString ("MsPos", "0"))
MsDur = Val(ReadPreferenceString ("MsDur", "0"))
IncrDepl = Val(ReadPreferenceString ("IncrDepl", "50"))
MsIncr = Val(ReadPreferenceString ("MsIncr", "0"))
IncrDeplCtrl = Val(ReadPreferenceString ("IncrDeplCtrl", "500"))
MsIncrCtrl = Val(ReadPreferenceString ("MsIncrCtrl", "0"))
TypeNotation = Val(ReadPreferenceString ("Notation", "1"))

SELanguage.s = ReadPreferenceString ("SELanguage", "")

ClosePreferences()

If SELanguage=""
  SELanguage = ChooseLanguageWindow()
  If SELanguage = "English"
    TypeNotation = 2
  ElseIf SELanguage = "Deutsch"
    TypeNotation = 3
  EndIf
EndIf

;
; Fenetre principale
;
MainWindow = OpenWindow(0,0,0,745,480,#PB_Window_SystemMenu|#PB_Window_ScreenCentered| #PB_Window_MinimizeGadget| #PB_Window_Invisible,"MonPiano "+#TVersion) 
If MainWindow And CreateGadgetList(WindowID(0))
  
  ;CouleurFond = CreateSolidBrush_(RGB(0, 0, 0)); fond noir pour la ToolBar
  ;SetClassLong_(WindowID(0), #GCL_HBRBACKGROUND, CouleurFond) 
  ;DeleteObject_(CouleurFond) 
  HideWindow(0, 0)
  
  ;- PARTITIONNEUR
  ;
  PImage = CreateImage(#IPART,#PLargeur,#PHauteur)
  PSDrawing = ImageGadget(#IPART, 5, #HPanel+10, #PLargeur, #PHauteur,PImage, #PB_Image_Border) 
  hdc = GetDC_(PSDrawing)
  NbScrollSteps = 400
  ScrollBarGadget  (#SBPart, 5, #HPanel+10+#PHauteur+4,#PLargeur+4, 18, 0, NbScrollSteps , 101)
  ButtonImageGadget(#RecordR,#PLargeur+15,#HPanel+10,20,20,Record)
  ButtonImageGadget(#PlayR,#PLargeur+37,#HPanel+10,20,20,Play)
  ButtonImageGadget(#PlayLoopR,#PLargeur+59,#HPanel+10,20,20,PlayLoop)
  ButtonImageGadget(#PauseR,#PLargeur+81,#HPanel+10,20,20,Pause)
  ButtonImageGadget(#StopR,#PLargeur+103,#HPanel+10,20,20,Stop)
  ButtonImageGadget(#DeleteR,#PLargeur+125,#HPanel+10,20,20,Delete)
  ButtonImageGadget(#StartR,#PLargeur+15,#HPanel+33,20,20,Start)
  ButtonImageGadget(#EndR,#PLargeur+37,#HPanel+33,20,20,EndR)
  ButtonImageGadget(#OpenR,#PLargeur+59,#HPanel+33,20,20,OpenR)
  ButtonImageGadget(#SaveR,#PLargeur+81,#HPanel+33,20,20,SaveR)
  ButtonImageGadget(#ZoomPlusR,#PLargeur+103,#HPanel+33,20,20,ZoomPlus)
  ButtonImageGadget(#ZoomMinusR,#PLargeur+125,#HPanel+33,20,20,ZoomMinus)
  ButtonImageGadget(#CopyR,#PLargeur+15,#HPanel+56,20,20,CopyR)
  ButtonImageGadget(#CutR,#PLargeur+37,#HPanel+56,20,20,CutR)
  ButtonImageGadget(#PasteR,#PLargeur+59,#HPanel+56,20,20,PasteR)
  ButtonImageGadget(#ClearR,#PLargeur+81,#HPanel+56,20,20,ClearR)
  ButtonImageGadget(#UndoR,#PLargeur+103,#HPanel+56,20,20,UndoR)
  ButtonImageGadget(#QuantizeR,#PLargeur+125,#HPanel+56,20,20,Quantize)
  
  Frame3DGadget(#SyncFrame,#PLargeur+15,#HPanel+131,131,60,"");Synchronised file
  TextGadget(#TNSync, #PLargeur+20, #HPanel+150, 120, 18, BRTranslate("None"),#PB_Text_Center)
  ButtonGadget(#BOSync, #PLargeur+20, #HPanel+168, 120, 16, "");Open
  
  Scale = 1
  Frame3DGadget(#MetronomeFrame,#PLargeur+15,#HPanel+191,131,87,"");Metronome
  ImageGadget(#Metronome, #PLargeur+20, #HPanel+208, 40, 65, MidMetronome)
  ButtonGadget(#MetroOnOff, #PLargeur+70, #HPanel+208, 64, 16, "");Run

  MetroOnOff = 0
  TextGadget(#MetroRythm, #PLargeur+70, #HPanel+228, 64, 14, "",#PB_Text_Center);Rythm
  StringGadget(#SMetroRythm, #PLargeur+70, #HPanel+244, 40,18,Str(MRythm),#PB_String_Numeric)
  TextGadget(#BPM, #PLargeur+110, #HPanel+250, 30, 18, "");BPM
  ButtonGadget(#BPMMinus, #PLargeur+70, #HPanel+262, 18, 12, "-")
  ButtonGadget(#BPMPlus, #PLargeur+92, #HPanel+262, 18, 12, "+")
  
  Frame3DGadget(#SpecFrame,4,#HPanel+10+#PHauteur+16,#PLargeur+6,34,"")
  TextGadget(#TNote, 10, #HPanel+10+#PHauteur+27, 40, 14, "");Note
  ComboBoxGadget(#CBNote, 50, #HPanel+10+#PHauteur+25, 67,150)
  TextGadget(#TPos, 155, #HPanel+10+#PHauteur+27, 50, 14, "");Position
  StringGadget(#SPos, 205, #HPanel+10+#PHauteur+26, 62,19,"-",#PB_String_Numeric)
  TextGadget(#TDur, 305, #HPanel+10+#PHauteur+27, 50, 14, ""); Duration
  StringGadget(#SDur, 355, #HPanel+10+#PHauteur+26, 62,19,"-",#PB_String_Numeric)
  TextGadget(#TVol, 455, #HPanel+10+#PHauteur+27, 50, 14, ""); Volume
  StringGadget(#SVol, 505, #HPanel+10+#PHauteur+26, 62,19,"-",#PB_String_Numeric)
  TicSound = LoadFromFileDX8Sound ("Images\Tic.wav")
  TacSound = LoadFromFileDX8Sound ("Images\Tac.wav")
  DrawPartition (0)
  
  ;- panel gadget   
  PanelGadget(#PanelGadget,0,5,745,#HPanel); cration de la bote  onglets
  ;
  ;- CLAVIER
  ;   
  OpenGadgetList(#PanelGadget ,"PANEL 1") ; Ajout d'un onglet 
  AddGadgetItem (#PanelGadget,-1,"");onglet SYNTH KEYBOARD
  ;
  ; Initialisation des notes

  Restore Notes
  ;
  OpenPreferences(#DatasFolder+"\MonPiano.prefs")
  For ct = 0 To 36
    Read NomAnglais$
    Read Nom$
    Read NomAllemand$
    If TypeNotation = 1
      Notes(ct)\Nom = Nom$
    ElseIf TypeNotation = 2
      Notes(ct)\Nom = NomAnglais$
    Else
      Notes(ct)\Nom = NomAllemand$
    EndIf
    Read Couleur$
    Notes(ct)\CouleurTouche = Couleur$
    Read TouchePC$
    Read TouchePCeng$
    Read TouchePCDeu$
    If SELanguage = "English"
      TouchePC$ = TouchePCeng$
    ElseIf SELanguage = "Deutsch"
      TouchePC$ = TouchePCDeu$
    EndIf
    PrefKey = Val(ReadPreferenceString ("Key"+Str(ct), "-1"))
    If PrefKey<>-1
      Notes(ct)\ToucheClavierPC = PrefKey
    Else
      Notes(ct)\ToucheClavierPC = GiveVirtualFromStr(TouchePC$)
    EndIf
    ;
    If Notes(ct)\CouleurTouche = "B"
      CImage = ToucheB;touche blanche
    Else
      CImage = ToucheN;touche noire
    EndIf
    ButtonImageGadget(ct+200,ct*20,0,20,100,CImage )
    ;
    ;Inscription des touches de raccourcis correspondantes sous les touches
    
    TextGadget(ct+300,ct*20,100,20,16,GiveAscFromVirtual.s (Notes(ct)\ToucheClavierPC),#PB_Text_Center)
    AddGadgetItem(#CBNote,-1,Notes(ct)\Nom)
  Next
  ClosePreferences()
  ;
  ;- BLOC CENTRAL
  ;  
  Frame3DGadget(#LoadFrame,4,125,170,47,""); Load Sounds
  ComboBoxGadget(#CBankChoice,13,140,152,260)
  ProgressBarGadget(#LoadBar, 13,162,152,7, 0,100,#PB_ProgressBar_Smooth);barre de chargement des fichiers sons
  ;
  TextGadget(#TPITCH, 187, 133, 40,18,"");PITCH
  PitchID = StringGadget(#PITCH, 222, 132, 50,18,"0",#PB_Text_Center|#PB_String_ReadOnly)
  ;
  TextGadget(#TSRMode, 187, 153, 40,18,""); MODE
  SRMode$=BRTranslate("Release")
  StringGadget(#SRMode, 222, 152, 50,18,"",#PB_Text_Center|#PB_String_ReadOnly)
  
  Frame3DGadget(#ControlFrame,285,125,451,47,""); Volumes
  TextGadget(#TVolBar, 290, 138, 105,12,"",#PB_Text_Center);Piano
  TrackBarGadget(#VolBar, 290, 149, 105, 18, 0, 20,#PB_TrackBar_Ticks)
  SetGadgetState(#VolBar,20)
  TextGadget(#TVolMBar, 400, 138, 105,12,"",#PB_Text_Center);Metronome
  TrackBarGadget(#VolMBar, 400, 149, 105, 18, 0, 20,#PB_TrackBar_Ticks)
  SetGadgetState(#VolMBar,20)
  TextGadget(#TVolFSBar, 510, 138, 105,12,"",#PB_Text_Center);Synchronised file
  TrackBarGadget(#VolFSBar, 510, 149, 105, 18, 0, 20,#PB_TrackBar_Ticks)
  SetGadgetState(#VolFSBar,20)
  TextGadget(#TBalBar, 625, 138, 105,12,"",#PB_Text_Center);Balance
  TrackBarGadget(#BalBar, 625, 149, 105, 18, 0, 20,#PB_TrackBar_Ticks)
  SetGadgetState(#BalBar,10)
  ;
  ExamineDirectory(0, #DatasFolder+"\BANKS", "")
  While NextDirectoryEntry() = 2
    If DirectoryEntryName()<>"." And DirectoryEntryName()<>".."
      AddGadgetItem (#CBankChoice,-1,DirectoryEntryName())
    EndIf 
  Wend
  SetGadgetState(#CBankChoice,0)
  Load_Sounds(#DatasFolder+"\BANKS\"+GetGadgetText(#CBankChoice)+"\")
  CloseGadgetList()
  ;
  ;- PANNELS INFOS
  ; Obtention de banques
  OpenGadgetList(#PanelGadget ,"PANEL 2"); ajout d'un nouvel onglet, idem suivants
  AddGadgetItem (#PanelGadget,-1,"")  ;Get new sounds    
  Frame3DGadget(#BankFrame,5,5,730,#HPanel-35,"");Sounds banks: how to get them?
  txgetSounds$ = "The 'piano' sound bank distributed with this software is sampled at a low rate to decrease the size of the zip package."
  txgetSounds$ + Chr(13)+"But MonPiano is able to play high fidelity sounds! You can get several more sounds banks (accordion, guitar, etc.) and increase your creativity from:"
  txgetSounds$ + Chr(13)+Chr(13)+Chr(13)+Chr(13)
  txgetSounds$ + "Sounds banks are made of a set of 37 sounds matching to the 37 notes of MonPiano. Most of them are completely free. Others are offered at a very reasonable price."
  txgetSounds$ + " Our site also presents the last news about the SoundEditor Project. See you soon!"+Chr(13)+Chr(13)
  txgetSounds$ + "You can create your own sounds banks: just record 37 sounds matching with the 37 notes of MonPiano. Name them: 'son0','son1','son2'...'son36' and put them in a folder that you will push into 'MonPianoDatas\BANKS'."
  txgetSounds$ + Chr(13)+"TIP: You can mix 2 or more different instruments in the same sounds bank. For exemple: guitar from son0 to son17 and piano from son18 to son36."
  TextGadget(#Text_Acces, 20, 22, 700, #HPanel-55,"");txgetSounds$
  ButtonGadget(#BWebLink,262,63,220,18,"www.freesoundeditor.com")
  CloseGadgetList()
  
  ; Info   
  OpenGadgetList(#PanelGadget ,"PANEL 3")  
  AddGadgetItem (#PanelGadget,-1,"")  ;Help    
  Frame3DGadget(#HelpFrame,5,5,730,#HPanel-35,""); Help
  ListViewGadget(#LIHChoice,13,25,180,#HPanel-65)
  ;Play and record your song
  txhelp1$ = "You can play on MonPiano using your mouse or your computer keyboard."
  txhelp1$ + " The actual version of MonPiano does NOT recognize a Midi keyboard connected to your PC."+Chr(13)
  txhelp1$ + "You can record your song using the up left button of the button set."
  txhelp1$ + " All the notes that you play are recorded and drawn on the partition. Then you can play or play loop your song with other buttons."
  ;Play and record simultaneously
  txhelp2$ = "Push the play or the play loop button. Then, push the record button."
  txhelp2$ + " You hear your song while you can continue to play and add notes to it."
  ;Edit your song
  txhelp3$ = "When you clic on a note onto the partition, you select it."
  txhelp3$ + " If you press the Ctrl key of your keyboard, you can clic on other notes "
  txhelp3$ + " and add them to your selection. You can also clic where there is no note and"
  txhelp3$ + " drag a selection rectangle moving your mouse with the left button pushed."+Chr(13)
  txhelp3$ + "When a selection is done, you can move it with the arrow keys of your keyboard."
  txhelp3$ + " If you press Ctrl while pressing the arrow keys, you move the selection quicker."
  txhelp3$ + " You can also copy or cut the selection with the corresponding buttons or using the usual"
  txhelp3$ + " Ctrl C and Ctrl X shortcuts. You can clear the selection or move it with your mouse."
  txhelp3$ + " You can change the position of the selection while modifying the 'Position' field"
  txhelp3$ + " located under the partition."
  ;Change the pitch
  txhelp4$ + "You can change the pitch of the notes before or while playing a song."
  txhelp4$ + " But with the actual version of MonPiano, the pitch modifications are not recorded."+Chr(13)
  txhelp4$ + "To change the pitch, use the mouse wheel of your mouse."
  ;Sustain and release
  txhelp5$ + "Sustain an release modes can be switched with the shift lock key."+Chr(13)
  txhelp5$ + "You can change this mode before or while playing a song."
  txhelp5$ + " But with the actual version of MonPiano, the sustain/release mode is not recorded."+Chr(13)
  ;Save your song
  txhelp6$ = "When you clic on the 'Save' button, you can choose to save your song as a wave file"
  txhelp6$ + " or as a Midi file. A Midi file can be edited later with MonPiano. A wave file can't."+Chr(13)
  txhelp6$ + "If you want to make a song with several instruments"
  txhelp6$ + " you must record each instrument separately and save each record as a wave file."
  txhelp6$ + " It's a good idea to save each record two times: one choosing 'wave' and one choosing 'Midi'."
  txhelp6$ + " You will use the wave version to synchronise your instruments and create your complete song"
  txhelp6$ + ", but you will keep the ability to change something if necessary."
  ;Multi-instruments song
  txhelp7$ = "MonPiano allow you to record only one instrument at a time."
  txhelp7$ + "But you can create a multi-instrument song using the 'synchronise' function."+Chr(13)
  txhelp7$ + "1- Record your first instrument."+Chr(13)
  txhelp7$ + "2- Save your play as a wave file."+Chr(13)
  txhelp7$ + "3- Clear the partition, clic on 'Synchronise' and re-open your song."+Chr(13)
  txhelp7$ + "4- Change the instrument and play with it hearing the first one!"+Chr(13)
  txhelp7$ + "If you want to add a third instrument, record again as the wave file, etc."
  ;Reserved keys
  txhelp8$ = "A few number of keys are reserved:"+Chr(13)
  txhelp8$ + "Ctrl: - increases or decrease a notes selection."+Chr(13)
  txhelp8$ + "      - increases the arrow keys actions."+Chr(13)
  txhelp8$ + "      - allows usage of the standard shortcuts:"+Chr(13)
  txhelp8$ + "        Ctrl C, Ctrl X, Ctrl V"+Chr(13)
  txhelp8$ + "Arrows : move the selected notes."+Chr(13)
  txhelp8$ + "Backspace : clear the selected notes."+Chr(13)
  txhelp8$ + "Shift lock : change the sustain/release mode."+Chr(13)
  txhelp8$ + "Mouse Wheel : change the pitch."
  ;
  TextGadget(#Text_Info, 205, 25, 520, #HPanel-60,"") ; txhelpX$      
  
  CloseGadgetList()
  ;
  ; Prfrences   
  OpenGadgetList(#PanelGadget ,"PANEL 4")  
  AddGadgetItem (#PanelGadget,-1,"");Preferences
  Frame3DGadget(#PrefFrame,5,8,180,#HPanel-38,"");Partition
  TextGadget(#TPBkColor, 40, 25, 130, 17,"");Backround color
  TextGadget(#TPRColor, 40, 43, 130, 17,"");Ruler color
  TextGadget(#TPLHColor, 40, 61, 130, 17,"");Horizontal lines color
  TextGadget(#TPDoColor, 40, 79, 130, 17,"");C line color
  TextGadget(#TPSolColor, 40, 97, 130, 17,"");G line color
  TextGadget(#TPLVColor, 40, 115, 130, 17,"");Vertical lines color
  TextGadget(#TPNotesColor, 40, 133, 130, 17,"");Notes color
  TextGadget(#TPSNotesColor, 40, 151, 140, 17,"");Selected notes color
  Color_ButtonGadget(#BPBkColor, 15, 23, 17, 17,TPBkColor,0)
  Color_ButtonGadget(#BPRColor, 15, 41, 17, 17,TPRColor,0)
  Color_ButtonGadget(#BPLHColor, 15, 59, 17, 17,TPLHColor,0)
  Color_ButtonGadget(#BPDoColor, 15, 77, 17, 17,TPDoColor,0)
  Color_ButtonGadget(#BPSolColor, 15, 95, 17, 17,TPSolColor,0)
  Color_ButtonGadget(#BPLVColor, 15, 113, 17, 17,TPLVColor,0)
  Color_ButtonGadget(#BPNotesColor, 15, 130, 17, 17,TPNotesColor,0)
  Color_ButtonGadget(#BPSNotesColor, 15, 149, 17, 17,TPSNotesColor,0)
  
  Frame3DGadget(#PrefDecay,200,8,200,69,"");Sustain / Release
  TextGadget(#TDecaySustain, 210, 30, 90, 17,"");Delay - Sustain:
  StringGadget(#SDecaySustain, 325, 28, 40,18,Str(SustainDelay),#PB_String_Numeric)
  TextGadget(#TMsDecaySustain, 375, 30, 15, 17,"");ms
  TextGadget(#TDecayRelease, 210, 53, 90, 17,"");Delay - Release:
  StringGadget(#SDecayRelease, 325, 51, 40,18,Str(ReleaseDelay),#PB_String_Numeric)
  TextGadget(#TMsDecayRelease, 375, 53, 15, 17,"");ms
  
  Frame3DGadget(#PrefDivers,415,8,320,69,"");Miscellaneous
  CheckBoxGadget(#ShowCursor, 425, 29, 300, 18, "");Always show cursor
  SetGadgetState(#ShowCursor,AlwaysShowCursor)
  TextGadget(#TPitchValue, 426, 54, 150, 17,"");Pitch variations:
  StringGadget(#SPitchValue,530,53,40,17,Str(PitchVar),#PB_String_Numeric)
  
  Frame3DGadget(#PrefUnit,200,85,535,85,"");Units
  TextGadget(#TRuler, 210, 104, 110, 17,"");Ruler unit:
  OptionGadget(#OGRulerSec, 345, 101, 80, 20, "");Seconde
  OptionGadget(#OGRulerMes, 445, 101, 200, 20, "") ;Metronome rythm
  SetGadgetState(#OGRulerSec,SecRuler)
  SetGadgetState(#OGRulerMes,~SecRuler+2)
  TextGadget(#TPosDisplay, 210, 124, 120, 17,"");Position unit:
  OptionGadget(#OGPosms, 345, 121, 38, 20, "");ms
  OptionGadget(#OGPosMes, 389, 121, 100, 20, "");1/1000th rythm
  SetGadgetState(#OGPosms,msPos)
  SetGadgetState(#OGPosMes,~msPos+2)
  TextGadget(#TDurDisplay, 540, 124, 120, 17,"");Duration:
  OptionGadget(#OGDurms, 585, 121, 38, 20, "");ms
  OptionGadget(#OGDurMes, 629, 121, 100, 20, "");1/1000th rythm
  SetGadgetState(#OGDurms,msDur)
  SetGadgetState(#OGDurMes,~msDur+2)
  TextGadget(#TArrowsMoving, 210, 144, 180, 17,"");<- and -> keys:
  StringGadget(#SArrowsMoving, 308, 142, 32,18,Str(IncrDepl),#PB_String_Numeric)
  OptionGadget(#OGArrms, 345, 141, 38, 20, "") ;ms
  OptionGadget(#OGArrMes, 389, 141, 100, 20, "");1/1000th rythm
  SetGadgetState(#OGArrms,msIncr)
  SetGadgetState(#OGArrMes,~msIncr+2)
  TextGadget(#TArrowsCtrlMoving, 493, 144, 90, 17,"");with Ctrl:
  StringGadget(#SArrowCtrlMoving, 540, 142, 32,18,Str(IncrDeplCtrl),#PB_String_Numeric)
  OptionGadget(#OGCtrlms, 585, 141, 38, 20, "") 
  OptionGadget(#OGCtrlMes, 629, 141, 100, 20, "");1/1000th rythm
  SetGadgetState(#OGCtrlms,msIncrCtrl)
  SetGadgetState(#OGCtrlMes,~msIncrCtrl+2)
  CloseGadgetList()
  ;
  ; Clavier et SELanguage   
  OpenGadgetList(#PanelGadget ,"PANEL 5")  
  AddGadgetItem (#PanelGadget,-1,"");Keyboard and language

  TextGadget(#TLanguage, 10, 8, 60, 17,"");Language:
  ComboBoxGadget(#CBLanguage, 70,5,100,100)
  Languages$ = GetAvailableLanguages ()
  ct = 1
  Repeat
    LName$ = StringField(Languages$, ct, "|")
    If LName$
      AddGadgetItem(#CBLanguage,-1,LName$)
    EndIf
    ct + 1
  Until LName$=""
  noi = CountGadgetItems(#CBLanguage) 
  ct = 0 
  While ct<noi And SELanguage.s<>GetGadgetItemText(#CBLanguage,ct,0) : ct + 1 : Wend 
  If SELanguage.s=GetGadgetItemText(#CBLanguage,ct,0) 
    SetGadgetState(#CBLanguage,ct) 
  Else 
    SetGadgetState(#CBLanguage,0) 
  EndIf 
  ButtonGadget(#BLanguage,175,5,95,21,"");Add/Modify

  TextGadget(#TNotation, 300, 8, 50, 17,"");Notation
  OptionGadget(#OGDoReMi, 350, 5, 140, 20, "") ;French (Do, Re, Mi...)
  OptionGadget(#OGCDE, 494, 5, 120, 20, "");English (A, B, C...)
  OptionGadget(#OGABH, 615, 5, 120, 20, "");German (A, B, H...)
  If TypeNotation = 1
    SetGadgetState(#OGDoReMi,1)
  ElseIf TypeNotation = 2
    SetGadgetState(#OGCDE,1)
  Else
    SetGadgetState(#OGABH,1)
  EndIf
  ;
  
  TextGadget(#TKeyboard, 10, 35, 100, 17,"");Keyboard keys:
  TextGadget(#TemoinTouche, 200, 35, 32,14,"0")
  ButtonGadget(#BJMJarre,205,116,100,18,"Jean-Michel Jarre")
  ButtonGadget(#BGershwin,315,116,100,18,"Gershwin")
  ButtonGadget(#BMozart,425,116,100,18,"Mozart")

  TextGadget(#THKeyboard,10,139,725,18,"",#PB_Text_Center);Clic on a note with your mouse, then press the key that must match with this note.
  TextGadget(#MessageTouche, 10, 158, 725,14,"")
  For ct = 0 To 36
    If Notes(ct)\CouleurTouche = "B"
      CImage = ToucheB;touche blanche
    Else
      CImage = ToucheN;touche noire
    EndIf
    ButtonImageGadget(ct+400,ct*20,50,20,50,CImage )
    ;
    ;Inscription des touches de raccourcis correspondantes sous les touches
    TextGadget(ct+500,ct*20,100,20,16,GiveAscFromVirtual.s (Notes(ct)\ToucheClavierPC),#PB_Text_Center)
  Next
   
  CloseGadgetList()
  ;
  ; Concept   
  OpenGadgetList(#PanelGadget ,"PANEL 6")  
  AddGadgetItem (#PanelGadget,-1,"");Conception and developpement

  Frame3DGadget(#ProjectFrame,5,10,730,#HPanel-40,"");"MonPiano "+#TVersion+"  -  "+BRTranslate("Created with PureBasic v3.91")
  TextGadget(#Text_concept, 20, 27, 700, #HPanel-60,"");Chr(13)+BRTranslate("- Jacobus: initial programmer 09/2004")+Chr(13)+BRTranslate("- Dobro: programmer and code cleaner.")+Chr(13)+BRTranslate("- ZapMan: programmer and code cleaner - DirectX8 integration, Midi file encoder/decoder, sequencer, language manager.")+Chr(13)+BRTranslate("- Le Soldat Inconnu : smart icons.")+Chr(13)+BRTranslate("- Want to add your name here?? Contact us!")+Chr(13)+Chr(13)+BRTranslate("Have you got the last version of MonPiano? Check it at: ")    
  ButtonGadget(#BWebLink2,312,115,220,20,"www.freesoundeditor.com")
  CloseGadgetList()
  
  PutTextsOnButtons ()
  ;  
  ;- boucle event
  MemSoundBank = 0
  JoueAuto = -1
  PlayNow = -1
  DraggingNote = -1
  DraggingRect = 0
  Quit = 0
  SetWindowCallback(@MonPianoCallBack()) ; Gestion du scrollbar
  MoveCursor=LoadCursor_(0, #IDC_SIZEALL)
  MetroTime = 0
  StartATime = GetTickCount_()
  RITime = GetTickCount_()
  RIOnOff = 0
  Metronome + 0
  NbPNotes = 0
  StartGTime = -2
  Volume = 10000
  mVolume = Volume
  TimeCursor = 0
  PlayLoop = 0
  RecordClignote = 0
  mRIOnOff = RIOnOff
  FicSync = 0
  LastUndo$=""
  IUndo = 1
  
  Repeat
    SetVolumeDX8Sound(Notes(0)\Son,10000)
    ;
    EventID.l = WindowEvent()
    ;
    ;
    ; RecordIcon
    ;
    If GetTickCount_() - RITime>400
      RITime = GetTickCount_()
      If RIOnOff = 0 : RIOnOff = 1 : Else : RIOnOff = 0 : EndIf
      If StartGTime = -1 Or StartGTime > 0
        If RIOnOff = 1
          SetGadgetState(#RecordR,RecordOn)
        Else
          SetGadgetState(#RecordR,RecordOff)
        EndIf
        RecordClignote = 1
      Else
        If RecordClignote
          SetGadgetState(#RecordR,Record)
          RecordClignote = 0
        EndIf
      EndIf
    EndIf
    ;
    If GetGadgetState(#PanelGadget)=4 ; Panneau de prfrence "Clavier et SELanguage"
      If StartGTime <> -2 Or PlayNow <> -1 Or TimeCursor <> 0
        StopPlay()
      EndIf
      If ChangeClavier = 0
        NoTouche = 0
        ChangeClavier = 1
      EndIf
      ANoTouche = NoTouche
      ;
      ; Appui/relachement des touches par l'utilisateur sur le clavier des prfrences
      ;
      If GetAsyncKeyState_(#VK_LBUTTON)
        GetCursorPos_(@CurPos.Point) ; Position du curseur relatif  la Zone survole
        Handle = WindowFromPoint_(CurPos\x, CurPos\y) ; Handle de la zone survole
        For ct = 0 To 36
          If GadgetID(ct+400)=Handle
            NoTouche = ct
          EndIf
        Next
        If NoTouche <> ANoTouche
          SetGadgetText(#MessageTouche,"")
          For ct = 0 To 36
            If ct<> NoTouche And Notes(ct)\ToucheClavierPC = Notes(NoTouche)\ToucheClavierPC
              SetGadgetText(#MessageTouche,BRTranslate("CAUTION!")+BRTranslate(" - This key is yet matching to the note #")+Str(ct))
            EndIf
          Next
        EndIf
      EndIf
      If mRIOnOff <> RIOnOff
        mRIOnOff = RIOnOff
        If RIOnOff
          If Notes(NoTouche)\CouleurTouche = "B"
            CImage = ToucheBE;touche blanche enfoncee
          Else
            CImage = ToucheNE;touche noire enfoncee
          EndIf
        Else
          If Notes(NoTouche)\CouleurTouche = "B"
            CImage = ToucheB;touche blanche enfoncee
          Else
            CImage = ToucheN;touche noire enfoncee
          EndIf
        EndIf
        SetGadgetState(NoTouche+400,CImage)
      EndIf
      
      If EventID = #WM_KEYDOWN
        KeyCode = EventwParam()&$FFFF
        Restore TouchesReservees
        Repeat
          Read TR
        Until TR = 0 Or TR = KeyCode
        If TR = KeyCode
          If TR
            SetGadgetText(#MessageTouche,BRTranslate("CAUTION!")+BRTranslate(" - This key ("+Str(KeyCode)+") is reserved And can't be used!!!"))
          EndIf
        Else
          Notes(NoTouche)\ToucheClavierPC = KeyCode
          SetGadgetText(NoTouche+500,GiveAscFromVirtual (Notes(NoTouche)\ToucheClavierPC))
          SetGadgetText(NoTouche+300,GiveAscFromVirtual (Notes(NoTouche)\ToucheClavierPC))
          SetGadgetText(#TemoinTouche,Str(Notes(NoTouche)\ToucheClavierPC))
          SetGadgetText(#MessageTouche,"")
          For ct = 0 To 36
            If ct<> NoTouche And Notes(ct)\ToucheClavierPC = Notes(NoTouche)\ToucheClavierPC
              SetGadgetText(#MessageTouche,BRTranslate("CAUTION!")+BRTranslate(" - The ")+GiveAscFromVirtual (Notes(NoTouche)\ToucheClavierPC)+BRTranslate(" key is matching many notes!"))
            EndIf
          Next
          If NoTouche <36
            NoTouche + 1
          EndIf
        EndIf
      EndIf
      If ANoTouche <> NoTouche
        If Notes(ANoTouche )\CouleurTouche = "B"
          CImage = ToucheB;touche blanche enfoncee
        Else
          CImage = ToucheN;touche noire enfoncee
        EndIf
        SetGadgetState(ANoTouche+400,CImage)
      EndIf
    Else
      ChangeClavier = 0
    EndIf
    If NotesJouees(0)\Num=-1 And PlayNow > 0
      If TimeCursor And StartGTime < 0
        DrawTimeCursor(0)
        TimeCursor = 0
      EndIf
      PlayNow = -1
    EndIf
    If StartGTime > 0 Or PlayNow > 0
      DrawTimeCursor(0)
      If StartGTime > 0
        TimeCursor = GetTickCount_()-StartGTime
      Else
        TimeCursor = GetTickCount_()-PlayNow 
      EndIf
      DrawTimeCursor(AlwaysShowCursor)
    EndIf    
    ;
    ; Metronome
    ;
    If PlayNow>0 Or StartGTime >0
      MetroTime = GetTickCount_()-PlayNow
    ElseIf StartGTime >0
      MetroTime = GetTickCount_()-StartGTime 
    Else
      MetroTime = GetTickCount_()-StartATime
    EndIf
    If MRythm>0
      While MetroTime >= 60000/MRythm
        MetroTime  - 60000/MRythm
        StartATime = GetTickCount_()
      Wend
      AMetronome = Metronome
      If Metronome  <> MetroTime*MRythm*16 /(60000)
        Metronome  = MetroTime*MRythm*16 /(60000)
        If MetroOnOff And AMetronome <> Metronome
          If Metronome = 0
            SetGadgetState(#Metronome,L1Metronome)
            PlayDX8Sound(TicSound,0)
          ElseIf Metronome = 1 Or Metronome = 15
            SetGadgetState(#Metronome,L2Metronome)
          ElseIf Metronome  = 2 Or Metronome  = 14
            SetGadgetState(#Metronome,L3Metronome)
          ElseIf Metronome  = 3 Or Metronome  = 13
            SetGadgetState(#Metronome,L4Metronome)
          ElseIf Metronome  = 4 Or Metronome  = 12
            SetGadgetState(#Metronome,MidMetronome)
          ElseIf Metronome  = 5 Or Metronome  = 11
            SetGadgetState(#Metronome,R1Metronome)
          ElseIf Metronome  = 6 Or Metronome  = 10
            SetGadgetState(#Metronome,R2Metronome)
          ElseIf Metronome  = 7 Or Metronome  = 9
            SetGadgetState(#Metronome,R3Metronome)
          ElseIf Metronome  = 8
            SetGadgetState(#Metronome,R4Metronome)
            PlayDX8Sound(TacSound,0)
          EndIf
        EndIf
      EndIf
    EndIf
    ;
    ;
    ;- Dragging mouse
    ;
    OverNote = -1
    InsidePart = 0
    GetCursorPos_(@OverPos.Point) 
    OverPos\x = OverPos\x-2
    OverPos\y = OverPos\y-2 
    GetWindowRect_(PSDrawing ,@SDRect.RECT) 
    If PtInRect_(SDRect,OverPos\x,OverPos\y) 
      InsidePart = 1
      OverPos\x - SDRect\Left
      OverPos\y - SDRect\Top
      ctnj = 0
      While NotesJouees(ctnj)\Num<>-1
        If PtInRect_(NotesJouees(ctnj)\ScreenRect,OverPos\x,OverPos\y)
          SetCursor_(MoveCursor)
          OverNote = ctnj
        EndIf
        ctnj + 1
      Wend
    EndIf ; If PtInRect_(SDRect,OverPos\x,OverPos\y)
    If GetAsyncKeyState_(#VK_LBUTTON)
      If DraggingRect And (MPos.Point\x<>OverPos\x Or MPos\y<>OverPos\y)
        If MPos.Point\x<>RelPos.Point\x Or MPos\y<>RelPos\y
          Set_Rect (RelPos.Point\x,RelPos\y,MPos.Point\x,MPos\y, FRect.Rect)
          DrawFocusRect_(hdc,FRect)
        EndIf
        If InsidePart = 0
          If OverPos\x>SDRect\Right-3
            OverPos\x = SDRect\Right-3
            If GetGadgetState(#SBPart)<(NbScrollSteps -100/Scale)
              RelPos.Point\x = RelPos.Point\x - (#PLargeur*Scale/100)
              SetGadgetState(#SBPart,GetGadgetState(#SBPart)+1)
              DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            EndIf
          EndIf
          If OverPos\x<SDRect\Left
            OverPos\x = SDRect\Left
            If GetGadgetState(#SBPart)
              RelPos.Point\x = RelPos.Point\x + (#PLargeur*Scale/100)
              SetGadgetState(#SBPart,GetGadgetState(#SBPart)-1)
              DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            EndIf
          EndIf
          If OverPos\y>SDRect\Bottom-3
            OverPos\y = SDRect\Bottom-3
          EndIf
          OverPos\x - SDRect\Left
          OverPos\y - SDRect\Top
        EndIf
        If RelPos.Point\x<>OverPos\x Or RelPos\y<>OverPos\y
          Set_Rect (RelPos.Point\x,RelPos\y,OverPos\x,OverPos\y, FRect.Rect)
          DrawFocusRect_(hdc,FRect)
          MPos\x = OverPos\x
          MPos\y = OverPos\y
          PStart = GetGadgetState(#SBPart)*#PLargeur*Scale/100
          GetAsyncKeyState_(#VK_CONTROL) ; Vide le buffer
          GetAsyncKeyState_(#VK_CONTROL)
          GetAsyncKeyState_(#VK_CONTROL)
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            ct = NotesJouees(ctnj)\Num
            PosInPixf.f = NotesJouees(ctnj)\StartTime/10000*#PLargeur*Scale
            PosInPix = Round(PosInPixf,0)-PStart
            If PosInPix>-1 And PosInPix<SDRect\Right-SDRect\Left-3
              NoteNum = Round(#PHauteur-13-(ct/2*(#PHauteur-15)/20),0)
              MustBeSelected = PtInRect_ (FRect, PosInPix ,NoteNum)
              If GetAsyncKeyState_(#VK_CONTROL)
                If MustBeSelected
                  MustBeSelected = 2+~NotesJouees(ctnj)\WasSelected
                Else
                  MustBeSelected = NotesJouees(ctnj)\WasSelected
                EndIf
              EndIf
              ;
              If MustBeSelected 
                If NotesJouees(ctnj)\Selected = 0
                  NotesJouees(ctnj)\Selected = 1
                  MPos\x=RelPos\x
                  MPos\y=RelPos\y
                  DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
                EndIf
              Else
                If NotesJouees(ctnj)\Selected = 1
                  NotesJouees(ctnj)\Selected = 0
                  MPos\x=RelPos\x
                  MPos\y=RelPos\y
                  DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
                EndIf
              EndIf
            EndIf
            ctnj + 1
          Wend
          Set_DurAndPos ()
        EndIf
      EndIf
      If DraggingNote<>-1
        If InsidePart = 0
          If OverPos\x>SDRect\Right-3
            OverPos\x = SDRect\Right-3
            If GetGadgetState(#SBPart)<(NbScrollSteps -100/Scale)
              RelPos.Point\x = RelPos.Point\x - (#PLargeur*Scale/100)
              SetGadgetState(#SBPart,GetGadgetState(#SBPart)+1)
              DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            EndIf
          EndIf
          If OverPos\x<SDRect\Left
            OverPos\x = SDRect\Left
            If GetGadgetState(#SBPart)
              RelPos.Point\x = RelPos.Point\x + (#PLargeur*Scale/100)
              SetGadgetState(#SBPart,GetGadgetState(#SBPart)-1)
              DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            EndIf
          EndIf
          If OverPos\y>SDRect\Bottom-3
            OverPos\y = SDRect\Bottom-3
          EndIf
          OverPos\x - SDRect\Left
          OverPos\y - SDRect\Top
        EndIf
        SetCursor_(MoveCursor)
        Distx = OverPos\x-RelPos.Point\x
        DistInTime = Round(Distx*10000/(#PLargeur*Scale),0)
        NewNote = Round((#PHauteur-10-OverPos\y+3)*20*2/(#PHauteur-15),0)
        If NewNote<0 : NewNote = 0 : EndIf
        If NewNote>36 : NewNote = 36 : EndIf
        If NotesJouees(DraggingNote)\Num<>NewNote Or DistInTime
          CopyForUndo ("DraggingNote")
          DistInNote = NewNote - NotesJouees(DraggingNote)\Num
          ;
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            If NotesJouees(ctnj)\Selected
              If NotesJouees(ctnj)\StartTime + DistInTime <0
                DistInTime = - NotesJouees(ctnj)\StartTime
              EndIf
              If NotesJouees(ctnj)\Num + DistInNote < 0
                DistInNote = - NotesJouees(ctnj)\Num
              EndIf
              If NotesJouees(ctnj)\Num + DistInNote >36
                DistInNote = 36 - NotesJouees(ctnj)\Num
              EndIf
            EndIf
            ctnj + 1
          Wend
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            If NotesJouees(ctnj)\Selected
              NotesJouees(ctnj)\Num + DistInNote 
              NotesJouees(ctnj)\StartTime + DistInTime
            EndIf
            ctnj + 1
          Wend
          Set_DurAndPos ()
          ;
          RelPos\x = OverPos\x
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          PosInPixf.f = NotesJouees(DraggingNote)\StartTime/10000*(#PLargeur*Scale)
          PosInPix = Round(PosInPixf,0)-PStart
          UseImage(#IPART) 
          StartDrawing(ImageOutput())
          Line(PosInPix ,0,0,10,#Red)
          StopDrawing()
          SetGadgetState(#IPART, UseImage(#IPART))
        EndIf ; If NotesJouees(DraggingNote)\Num<>NewNote Or DistInTime
      EndIf ; If DraggingNote<>-1
    Else
      If LastUndo$ = "DraggingNote"
        LastUndo$ = ""
      EndIf
    EndIf ; If GetAsyncKeyState_(#VK_LBUTTON)
    ;
    ;
    If son_charge
      ;
      ;- Player automatique
      ;
      If PlayNow>0
        StartTime = GetTickCount_()-PlayNow
        Finished = 1
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          ct = NotesJouees(ctnj)\Num
          If NotesJouees(ctnj)\StartTime<=StartTime And (NotesJouees(ctnj)\StartTime+NotesJouees(ctnj)\Duration)>=StartTime 
            Finished = 0
            If Notes(ct)\MustPlay = 0
              Notes(ct)\IsPlaying = 0
              Notes(ct)\TempVolume = NotesJouees(ctnj)\Volume*Volume/10000
            EndIf
            Notes(ct)\MustPlay = 2
          EndIf
          If NotesJouees(ctnj)\StartTime>StartTime 
            Finished = 0
          EndIf
          ctnj+1
        Wend
        ct = 0
        While Notes(ct)\Nom<>""
          If Notes(ct)\MustPlay = 1
            Notes(ct)\MustPlay = 0
          ElseIf Notes(ct)\MustPlay = 2
            Notes(ct)\MustPlay = 1
          EndIf
          ct + 1
        Wend
        If Finished
          If PlayLoop
            If PlayNow > 0
              PlayNow = GetTickCount_()
              If StartGTime > 0
                StartGTime  = PlayNow 
              EndIf
              PlayDX8SoundAt (FicSync,0,0)
            EndIf
          ElseIf StartGTime < 0
            PlayNow = -1
            StopDX8Sound (FicSync)
          EndIf
        EndIf
      EndIf
      ;
      ; Appui/relachement des touches par l'utilisateur
      ;
      If ChangeClavier = 0
        If GetAsyncKeyState_(#VK_LBUTTON)
          GetCursorPos_(@CurPos.Point) ; Position du curseur relatif  la Zone survole
          Handle = WindowFromPoint_(CurPos\x, CurPos\y) ; Handle de la zone survole
        Else
          Handle = 0
        EndIf
        ;
        KeyCode = EventwParam()&$FFFF
        For ct = 0 To 36
          If (GetAsyncKeyState_(Notes(ct)\ToucheClavierPC) And GetAsyncKeyState_(#VK_CONTROL)=0) Or (GadgetID(ct+200)=Handle And DraggingRect = 0)
            UserPlay = 1
          Else
            UserPlay = 0
          EndIf
          If UserPlay Or Notes(ct)\MustPlay
            If GetFocus_()=GadgetID(#CBankChoice)
              ActivateGadget(#LoadBar) ; pour retirer le focus de #CBankChoice  (sinon, il ragit aux touches!)
            EndIf
            If Notes(ct)\IsPlaying <> 1
              Notes(ct)\IsPlaying = 1
              If StartGTime = -1
                StartGTime = GetTickCount_()
              EndIf
              StartTime = GetTickCount_()-StartGTime
              If UserPlay
                Notes(ct)\TempVolume = Volume
              EndIf
              SetFrequencyDX8Sound(Notes(ct)\Son,Frequency)
              SetPanDX8Sound(Notes(ct)\Son,Pan)
              SetVolumeDX8Sound(Notes(ct)\Son,Notes(ct)\TempVolume-10000)

              PlayDX8Sound(Notes(ct)\Son,0)
              If Notes(ct)\CouleurTouche = "B"
                CImage = ToucheBE;touche blanche enfoncee
              Else
                CImage = ToucheNE;touche noire enfoncee
              EndIf
              SetGadgetState(ct+200,CImage)
              If UserPlay And StartGTime>0
                CopyForUndo ("Record")
                ctnj = 0
                While NotesJouees(ctnj)\Num<>-1 : ctnj + 1 : Wend
                NotesJouees(ctnj)\Num = ct
                NotesJouees(ctnj)\StartTime = StartTime
                NotesJouees(ctnj)\Volume = Volume
                NotesJouees(ctnj)\Duration = -1
              EndIf
            EndIf
          Else
            If Notes(ct)\IsPlaying = 1
              Notes(ct)\IsPlaying = 2
              EndTime = GetTickCount_()-StartGTime
              If StartGTime>0
                ctnj = 0
                While NotesJouees(ctnj)\Num<>-1 : ctnj + 1 : Wend
                While NotesJouees(ctnj)\Num<>ct  And ctnj : ctnj - 1 : Wend
                If NotesJouees(ctnj)\Num=ct And NotesJouees(ctnj)\Duration = -1
                  NotesJouees(ctnj)\Duration = EndTime - NotesJouees(ctnj)\StartTime
                  DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
                EndIf
              EndIf
              ;
              If Notes(ct)\CouleurTouche = "B"
                CImage = ToucheB;touche blanche
              Else
                CImage = ToucheN;touche noire
              EndIf
              SetGadgetState(ct+200,CImage)
            EndIf
          EndIf
        Next
      EndIf
    EndIf
    ;
    ;- Autres evenements clavier / souris
    ;
    ; CLAVIER
    mSRMode$ = SRMode$
    If GetKeyState_(20)&$FF
      SRMode$=BRTranslate("Sustain")
    Else
      SRMode$=BRTranslate("Release")
    EndIf
    If mSRMode$ <> SRMode$
      SetGadgetText(#SRMode,SRMode$)
    EndIf
    If GetAsyncKeyState_(#VK_CONTROL) And IUndo = 1
      SetGadgetState(#UndoR,RedoR)
      IUndo = 0
      RedoTip()
    EndIf
    If GetAsyncKeyState_(#VK_CONTROL)=0 And IUndo = 0
      SetGadgetState(#UndoR,UndoR)
      IUndo = 1
      UndoTip()
    EndIf
    If EventID = #WM_Keydown
      If GetAsyncKeyState_(#VK_Z) And GetAsyncKeyState_(#VK_CONTROL) ; Z - Undo
        UndoMP()
      EndIf
      If GetAsyncKeyState_(#VK_Y) And GetAsyncKeyState_(#VK_CONTROL) ; Y - Redo
        RedoMP()
      EndIf
      If GetAsyncKeyState_(#VK_A) And GetAsyncKeyState_(#VK_CONTROL) ; A - Select All
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          NotesJouees(ctnj)\Selected = 1
          ctnj + 1
        Wend
        DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
        Set_DurAndPos ()
      EndIf
      If GetAsyncKeyState_(#VK_BACK) Or GetAsyncKeyState_(#VK_DELETE) Or GetAsyncKeyState_(#VK_CLEAR) ; BackSpace - Clear
        If GetFocus_()<>GadgetID(#SDur) And GetFocus_()<>GadgetID(#SVol) And GetFocus_()<>GadgetID(#SPos)
          ClearSelection()
        EndIf
      EndIf
      If GetAsyncKeyState_(#VK_UP) ; Flche haute
        CopyForUndo ("UP")
        MaxNote= 0
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          If NotesJouees(ctnj)\Selected
            If NotesJouees(ctnj)\Num>MaxNote : MaxNote = NotesJouees(ctnj)\Num : EndIf
          EndIf
          ctnj + 1
        Wend
        If MaxNote < 36
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            If NotesJouees(ctnj)\Selected
              NotesJouees(ctnj)\Num + 1
            EndIf
            ctnj + 1
          Wend
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          Set_DurAndPos ()
        EndIf
      EndIf
      If GetAsyncKeyState_(#VK_DOWN) ; Flche basse
        CopyForUndo ("DOWN")
        MinNote= 100
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          If NotesJouees(ctnj)\Selected
            If NotesJouees(ctnj)\Num<MinNote : MinNote = NotesJouees(ctnj)\Num : EndIf
          EndIf
          ctnj + 1
        Wend
        If MinNote > 0
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            If NotesJouees(ctnj)\Selected
              NotesJouees(ctnj)\Num - 1
            EndIf
            ctnj + 1
          Wend
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          Set_DurAndPos ()
        EndIf
      EndIf
      If GetAsyncKeyState_(#VK_LEFT) ; Flche gauche
        CopyForUndo ("LEFT")
        MinPos= 100
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          If NotesJouees(ctnj)\Selected
            If NotesJouees(ctnj)\StartTime <MinPos: MinPos= NotesJouees(ctnj)\StartTime : EndIf
          EndIf
          ctnj + 1
        Wend
        If MinPos> 0
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            If NotesJouees(ctnj)\Selected
              If GetAsyncKeyState_(#VK_CONTROL)
                If MsIncr 
                  NotesJouees(ctnj)\StartTime - IncrDeplCtrl
                Else
                  NotesJouees(ctnj)\StartTime - IncrDeplCtrl*60/MRythm
                EndIf
              Else
                If MsIncr 
                  NotesJouees(ctnj)\StartTime - IncrDepl
                Else
                  NotesJouees(ctnj)\StartTime - IncrDepl*60/MRythm
                EndIf
              EndIf
            EndIf
            ctnj + 1
          Wend
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          Set_DurAndPos ()
        EndIf
      EndIf
      If GetAsyncKeyState_(#VK_RIGHT) ; Flche droite
        CopyForUndo ("RIGHT")
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          If NotesJouees(ctnj)\Selected
              If GetAsyncKeyState_(#VK_CONTROL)
                If MsIncr 
                  NotesJouees(ctnj)\StartTime + IncrDeplCtrl
                Else
                  NotesJouees(ctnj)\StartTime + IncrDeplCtrl*60/MRythm
                EndIf
              Else
                If MsIncr 
                  NotesJouees(ctnj)\StartTime + IncrDepl
                Else
                  NotesJouees(ctnj)\StartTime + IncrDepl*60/MRythm
                EndIf
              EndIf
          EndIf
          ctnj + 1
        Wend
        DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
        Set_DurAndPos ()
      EndIf
    EndIf
    ;
    ; SOURIS
    ;
    If EventID.l = #WM_MOUSEWHEEL
      s.l=-(EventwParam() >> 16)/120*PitchVar
      Frequency + s
      ActivateGadget(#TPITCH)
      For ct = 0 To 36
        If Notes(ct)\IsPlaying <> 0
          SetFrequencyDX8Sound(Notes(ct)\Son,Frequency)
        EndIf
      Next
      SetGadgetText(#PITCH,Str(Frequency-Sound_Frequency))
    EndIf
    ;
    If EventID.l = #WM_LBUTTONDOWN
      If InsidePart
        SetFocus_(PitchID) ;pour enlever le focus de Vol, Dur ou Pos
      EndIf
      UndoDone = 0
      GetAsyncKeyState_(#VK_CONTROL) ; Vide le buffer
      GetAsyncKeyState_(#VK_CONTROL)
      GetAsyncKeyState_(#VK_CONTROL)
      RelPos\x = OverPos\x
      RelPos\y = OverPos\y
      If OverNote<>-1
        If NotesJouees(OverNote)\Selected = 0
          If GetAsyncKeyState_(#VK_CONTROL) = 0
            ctnj = 0
            While NotesJouees(ctnj)\Num<>-1
              NotesJouees(ctnj)\Selected = 0
              ctnj + 1
            Wend
          EndIf
          NotesJouees(OverNote)\Selected = 1
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
        ElseIf GetAsyncKeyState_(#VK_CONTROL)
          NotesJouees(OverNote)\Selected = 0
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
        EndIf
        DraggingNote = OverNote
      ElseIf InsidePart
        If GetAsyncKeyState_(#VK_CONTROL) = 0
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            NotesJouees(ctnj)\Selected = 0
            ctnj + 1
          Wend
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
        EndIf
        DraggingRect = 1
        MPos\x = OverPos\x
        MPos\y = OverPos\y
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          NotesJouees(ctnj)\WasSelected = NotesJouees(ctnj)\Selected
          ctnj + 1
        Wend
      EndIf
      If InsidePart
        Set_DurAndPos ()
      EndIf
    EndIf
    ;
    If GetAsyncKeyState_(#VK_LBUTTON) = 0
      DraggingNote = -1
      If DraggingRect
        If RelPos\x = OverPos\x And RelPos\y = OverPos\y ; Simple clic - on va juste positionner le curseur
          PStart = GetGadgetState(#SBPart)*#PLargeur*Scale/100
          DrawTimeCursor(0)
          TimeCursor = (RelPos\x+PStart)*10000/(#PLargeur*Scale)
          DrawTimeCursor(0)
          If PlayNow > 0
            PlayNow = GetTickCount_() - TimeCursor
          EndIf
          If StartGTime > 0
            StartGTime = GetTickCount_() - TimeCursor
          EndIf
          If FicSync And (StartGTime > 0 Or PlayNow > 0)
            PlayDX8SoundAt (FicSync,0,TimeCursor)
          EndIf
        EndIf
        If MPos.Point\x<>RelPos.Point\x Or MPos\y<>RelPos\y
          Set_Rect (RelPos.Point\x,RelPos\y,MPos.Point\x,MPos\y, FRect.Rect)
          DrawFocusRect_(hdc,FRect)
        EndIf
        DraggingRect = 0
      EndIf
    EndIf
    ;
    ;- Evenements Gadgets
    ;
    If EventID.l = #PB_EventGadget
      If son_charge<>1
        MessageRequester(BRTranslate("CAUTION!"), BRTranslate("Unable de load a sounds bank!"),#PB_MessageRequester_Ok) 
        Load_Sounds("") 
      EndIf
      Select EventGadgetID()
        Case #UndoR
          If GetAsyncKeyState_(#VK_CONTROL)
            RedoMP()
          Else
            UndoMP()
          EndIf
        Case #OpenR
          CopyForUndo ("Open")
          For ct = 0 To #MaxNbNotes
            NotesJouees(ct)\Num = -1
          Next
          ReadMidiFile()
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          ;
        Case #PlayR
          LastUndo$ = ""
          If StartGTime > 0
            PlayNow = StartGTime 
          Else
            StartGTime = -2
            PlayNow = GetTickCount_() - TimeCursor
          EndIf
          PlayLoop = 0
          If FicSync
            PlayDX8SoundAt (FicSync,0,TimeCursor)
          EndIf
          ;
        Case #PlayLoopR
          LastUndo$ = ""
          If StartGTime > 0
            PlayNow = StartGTime 
          Else
            StartGTime = -2
            PlayNow = GetTickCount_() - TimeCursor
          EndIf
          PlayLoop = 1
          If FicSync
            PlayDX8SoundAt (FicSync,0,TimeCursor)
          EndIf
          ;
        Case #StartR
          LastUndo$ = ""
          DrawTimeCursor(0)
          TimeCursor = 1
          DrawTimeCursor(1)
          TimeCursor = 0
          If PlayNow > 0
            PlayNow = GetTickCount_() - TimeCursor
          EndIf
          If StartGTime > 0
            StartGTime = GetTickCount_() - TimeCursor
          EndIf
          ;
        Case #EndR
          LastUndo$ = ""
          DrawTimeCursor(0)
          EndOfTime = 0
          ctnj = 0
          While NotesJouees(ctnj)\Num<>-1
            If NotesJouees(ctnj)\StartTime > EndOfTime
              EndOfTime = NotesJouees(ctnj)\StartTime
            EndIf
            ctnj + 1
          Wend
          If ctnj
            TimeCursor = NotesJouees(ctnj-1)\StartTime + NotesJouees(ctnj-1)\Duration
            DrawTimeCursor(1)
            If PlayNow > 0
              PlayNow = GetTickCount_() - TimeCursor
            EndIf
            If StartGTime > 0
              StartGTime = GetTickCount_() - TimeCursor
            EndIf
          EndIf
          ;
        Case #RecordR
          LastUndo$ = ""
          If PlayNow > 0
            StartGTime = PlayNow 
          Else
            PlayNow = -1
            If TimeCursor
              StartGTime = GetTickCount_() - TimeCursor
            Else
              StartGTime = -1
            EndIf
          EndIf
          If FicSync
            PlayDX8SoundAt (FicSync,0,TimeCursor)
          EndIf
          ;
        Case #StopR
          LastUndo$ = ""
          StopPlay()
          ;- Save 
        Case #SaveR
          LastUndo$ = ""
          SaveWindow(FSyncName$)
          ;
        Case #PauseR
          LastUndo$ = ""
          StopPausePlay()
          ;
        Case #ClearR
          ClearSelection()
          ;
        Case #DeleteR
          CopyForUndo ("Clear all")
          StartGTime = -2
          PlayNow = -1
          For ct = 0 To #MaxNbNotes
            NotesJouees(ct)\Num = -1
          Next
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          ;
        Case #CBankChoice 
          If GetGadgetState(#CBankChoice) < 0     
            SetGadgetState(#CBankChoice,0)
          EndIf
          If GetGadgetState(#CBankChoice) <> MemSoundBank
            SetGadgetState(#LoadBar,0); remise  zro de la barre de chargement
            Load_Sounds(#DatasFolder+"\BANKS\"+GetGadgetText(#CBankChoice)+"\")
            MemSoundBank = GetGadgetState(#CBankChoice)
          EndIf
          ;
        Case #VolBar
          Volume = Round(Log(GetGadgetState(#VolBar)+1)*10000/3.0445,0)
          For ct = 0 To 36
            If Notes(ct)\IsPlaying = 1
              SetVolumeDX8Sound(Notes(ct)\Son,(Notes(ct)\TempVolume*Volume/10000)-10000)
            EndIf
          Next
          ;
        Case #VolMBar
          MVolume = Round(Log(GetGadgetState(#VolMBar)+1)*10000/3.0445,0)
          SetVolumeDX8Sound(TicSound,MVolume-10000)
          SetVolumeDX8Sound(TacSound,MVolume-10000)
          ;
        Case #VolFSBar
          FSVolume = Round(Log(GetGadgetState(#VolFSBar)+1)*10000/3.0445,0)
          SetVolumeDX8Sound(FicSync,FSVolume-10000)
          ;
        Case #BalBar
          ppan = Sqr(GetGadgetState(#BalBar)*1000)*100
          Pan = ppan-10000
          For ct = 0 To 36
            If Notes(ct)\IsPlaying <> 0
              SetPanDX8Sound(Notes(ct)\Son,Pan)
            EndIf
          Next
          ;
        Case #MetroOnOff 
          If MetroOnOff
            MetroOnOff = 0
            SetGadgetText(#MetroOnOff,BRTranslate("Run"))
          Else
            MetroOnOff = 1
            SetGadgetText(#MetroOnOff,BRTranslate("Stop"))
          EndIf
          ;
        Case #SMetroRythm
          MRythm = Val(GetGadgetText(#SMetroRythm))
          If MRythm>400
            MRythm = 400
            SetGadgetText(#SMetroRythm,Str(MRythm))
          EndIf
          If SecRuler = 0
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            Set_DurAndPos ()
          EndIf
          ;
        Case #BPMPlus
          MRythm +1
          SetGadgetText(#SMetroRythm,Str(MRythm))
          If SecRuler = 0
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            Set_DurAndPos ()
          EndIf
          ;
        Case #BPMMinus
          MRythm -1
          SetGadgetText(#SMetroRythm,Str(MRythm))
          If SecRuler = 0
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
            Set_DurAndPos ()
          EndIf
          ;
        Case #ZoomPlusR
          Scale +1
          PosSB = GetGadgetState(#SBPart)
          FreeGadget(#SBPart)
          UseWindow(0)
          ScrollBarGadget  (#SBPart, 5, #HPanel+10+#PHauteur+4,#PLargeur+5, 18, 0, NbScrollSteps , 100/Scale)
          SetGadgetState(#SBPart,PosSB)
          DrawPartition (PosSB*#PLargeur*Scale/100)
          ;
        Case #ZoomMinusR
          If Scale>1
            Scale -1
            PosSB = GetGadgetState(#SBPart)
            FreeGadget(#SBPart)
            UseWindow(0)
            ScrollBarGadget  (#SBPart, 5, #HPanel+10+#PHauteur+4,#PLargeur+5, 18, 0, NbScrollSteps , 100/Scale)
            SetGadgetState(#SBPart,PosSB)
            DrawPartition (PosSB*#PLargeur*Scale/100)
          EndIf
          ;
        Case #SPos
          CopyForUndo ("Pos")
          If GetGadgetText(#SPos)<>"-"
            LPos = -1
            ctnj = 0
            While NotesJouees(ctnj)\Num<>-1
              If NotesJouees(ctnj)\Selected
                If NotesJouees(ctnj)\StartTime < LPos Or LPos = -1
                  LPos = NotesJouees(ctnj)\StartTime
                EndIf
              EndIf
              ctnj + 1
            Wend
            ctnj = 0
            While NotesJouees(ctnj)\Num<>-1
              If NotesJouees(ctnj)\Selected
                NotesJouees(ctnj)\StartTime - LPos + Val(GetGadgetText(#SPos))
              EndIf
              ctnj + 1
            Wend
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #SDur
          CopyForUndo ("Dur")
          If GetGadgetText(#SDur)<>"-"
            LDur = Val(GetGadgetText(#SDur))
            If LDur<20
              LDur = 20
            EndIf
            ctnj = 0
            While NotesJouees(ctnj)\Num<>-1
              If NotesJouees(ctnj)\Selected
                NotesJouees(ctnj)\Duration = LDur
              EndIf
              ctnj + 1
            Wend
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
         Case #SVol
          CopyForUndo ("Vol")
          If GetGadgetText(#SVol)<>"-"
            LVol= Val(GetGadgetText(#SVol))
            ctnj = 0
            While NotesJouees(ctnj)\Num<>-1
              If NotesJouees(ctnj)\Selected
                NotesJouees(ctnj)\Volume = LVol
              EndIf
              ctnj + 1
            Wend
          EndIf
          ;
         Case #CBNote
          CopyForUndo ("Change Note")
          If GetGadgetState(#CBNote)>-1
            ctnj = 0
            While NotesJouees(ctnj)\Num<>-1
              If NotesJouees(ctnj)\Selected
                NotesJouees(ctnj)\Num = GetGadgetState(#CBNote)
              EndIf
              ctnj + 1
            Wend
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPBkColor
          Color = ColorRequester()
          If Color>0
            TPBkColor = Color
            Color_ButtonGadget(#BPBkColor, 20, 23, 17, 17,TPBkColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPRColor
          Color = ColorRequester()
          If Color>0
            TPRColor = Color
            Color_ButtonGadget(#BPRColor, 20, 41, 17, 17,TPRColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPLHColor
          Color = ColorRequester()
          If Color>0
            TPLHColor = Color
            Color_ButtonGadget(#BPLHColor, 20, 59, 17, 17,TPLHColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPDoColor
          Color = ColorRequester()
          If Color>0
            TPDoColor = Color
            Color_ButtonGadget(#BPDoColor, 20, 77, 17, 17,TPDoColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPSolColor
          Color = ColorRequester()
          If Color>0
            TPSolColor = Color
            Color_ButtonGadget(#BPSolColor, 20, 95, 17, 17,TPSolColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPLVColor
          Color = ColorRequester()
          If Color>0
            TPLVColor = Color
            Color_ButtonGadget(#BPLVColor, 20, 113, 17, 17,TPLVColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPNotesColor
          Color = ColorRequester()
          If Color>0
            TPNotesColor = Color
            Color_ButtonGadget(#BPNotesColor, 20, 130, 17, 17,TPNotesColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #BPSNotesColor
          Color = ColorRequester()
          If Color>0
            TPSNotesColor = Color
            Color_ButtonGadget(#BPSNotesColor, 20, 149, 17, 17,TPSNotesColor,1)
            DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          EndIf
          ;
        Case #SDecaySustain
          SustainDelay = Val(GetGadgetText(#SDecaySustain))
          If SustainDelay = 0
            SustainDelay = 100
          EndIf
          ;
        Case #SDecayRelease
          ReleaseDelay = Val(GetGadgetText(#SDecayRelease))
          If ReleaseDelay = 0
            ReleaseDelay = 100
          EndIf
          ;
        Case #OGRulerSec
          If GetGadgetState(#OGRulerSec) : SecRuler = 1 : Else : SecRuler = 0 : EndIf
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
        ;
        Case #OGRulerMes
          If GetGadgetState(#OGRulerSec) : SecRuler = 1 : Else : SecRuler = 0 : EndIf
          DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
          ;
        Case #OGPosms
          If GetGadgetState(#OGPosms) : msPos = 1 : Else : msPos = 0 : EndIf
          Set_DurAndPos ()
          ;
        Case #OGPosMes
          If GetGadgetState(#OGPosms) : msPos = 1 : Else : msPos = 0 : EndIf
          Set_DurAndPos ()
          ;
        Case #OGDurms
          If GetGadgetState(#OGDurms) : msDur = 1 : Else : msDur = 0 : EndIf
          Set_DurAndPos ()
          ;
        Case #OGDurMes
          If GetGadgetState(#OGDurms) : msDur = 1 : Else : msDur = 0 : EndIf
          Set_DurAndPos ()
          ;
        Case #OGArrms
          If GetGadgetState(#OGArrms) : MsIncr = 1 : Else : MsIncr = 0 : EndIf
          ;
        Case #OGArrMes
          If GetGadgetState(#OGArrms) : MsIncr = 1 : Else : MsIncr = 0 : EndIf
        ;
        Case #SArrowsMoving
          IncrDepl = Val(GetGadgetText(#SArrowsMoving))
          ;
        Case #SArrowCtrlMoving
          IncrDeplCtrl = Val(GetGadgetText(#SArrowCtrlMoving))
          ;
        Case #ShowCursor
          AlwaysShowCursor = GetGadgetState(#ShowCursor)
          ;
        Case #SPitchValue
          PitchVar = Val(GetGadgetText(#SPitchValue))
          ;
        Case #OGDoReMi
          DefiniNotation()
        ;
        Case #OGCDE
          DefiniNotation()
        ;
        Case #OGABH
          DefiniNotation()
        ;
        Case #BJMJarre
          Restore Notes
          For ct = 0 To 36
            Read NomAnglais$
            Read Nom$
            Read NomAllemand$
            Read Couleur$
            Read TouchePC$
            Read TouchePCeng$
            Read TouchePCDeu$
            Notes(ct)\ToucheClavierPC = GiveVirtualFromStr(TouchePC$)
            SetGadgetText(ct+500,GiveAscFromVirtual (Notes(ct)\ToucheClavierPC))
            SetGadgetText(ct+300,GiveAscFromVirtual (Notes(ct)\ToucheClavierPC))
          Next ct
          ;
        Case #BGershwin
          Restore Notes
          For ct = 0 To 36
            Read NomAnglais$
            Read Nom$
            Read NomAllemand$
            Read Couleur$
            Read TouchePC$
            Read TouchePCeng$
            Read TouchePCDeu$
            Notes(ct)\ToucheClavierPC = GiveVirtualFromStr(TouchePCeng$)
            SetGadgetText(ct+500,GiveAscFromVirtual (Notes(ct)\ToucheClavierPC))
            SetGadgetText(ct+300,GiveAscFromVirtual (Notes(ct)\ToucheClavierPC))
          Next ct
          ;
        Case #BMozart
          Restore Notes
          For ct = 0 To 36
            Read NomAnglais$
            Read Nom$
            Read NomAllemand$
            Read Couleur$
            Read TouchePC$
            Read TouchePCeng$
            Read TouchePCDeu$
            Notes(ct)\ToucheClavierPC = GiveVirtualFromStr(TouchePCDeu$)
            SetGadgetText(ct+500,GiveAscFromVirtual (Notes(ct)\ToucheClavierPC))
            SetGadgetText(ct+300,GiveAscFromVirtual (Notes(ct)\ToucheClavierPC))
          Next ct
          ;
        Case #BLanguage
          LanguageWindow()
          PutTextsOnButtons ()
        ;
        Case #CBLanguage
          If GetGadgetText(#CBLanguage)
            If SELanguage <> GetGadgetText(#CBLanguage)
              SELanguage = GetGadgetText(#CBLanguage)
              PutTextsOnButtons ()
            EndIf
          EndIf
          ;
        Case #BWebLink 
          ShellExecute_(WindowID(),"open","http:\\www.freesoundeditor.com","","",#SW_SHOWNORMAL)
        ;
        Case #BWebLink2 
          ShellExecute_(WindowID(),"open","http:\\www.freesoundeditor.com","","",#SW_SHOWNORMAL)
        ;
        Case #LIHChoice
          Select GetGadgetState(#LIHChoice)
            Case 0
              SetGadgetText(#Text_Info,BRTranslate(txhelp1$))
            Case 1
              SetGadgetText(#Text_Info,BRTranslate(txhelp2$))
            Case 2
              SetGadgetText(#Text_Info,BRTranslate(txhelp3$))
            Case 3
              SetGadgetText(#Text_Info,BRTranslate(txhelp4$))
            Case 4
              SetGadgetText(#Text_Info,BRTranslate(txhelp5$))
            Case 5
              SetGadgetText(#Text_Info,BRTranslate(txhelp6$))
            Case 6
              SetGadgetText(#Text_Info,BRTranslate(txhelp7$))
            Case 7
              SetGadgetText(#Text_Info,BRTranslate(txhelp8$))
            Case 8
              SetGadgetText(#Text_Info,BRTranslate(txhelp9$))
            Case 9
              SetGadgetText(#Text_Info,BRTranslate(txhelp10$))
          EndSelect
          ;
        Case #BOSync
          FSyncName$ = OpenFileRequester ("", "", BRTranslate("Wave file")+"|*.Wav", BRTranslate("Wave file")+"|*.Wav")
          If FSyncName$
            OpenWindow(60,0,0,200,30,#PB_Window_ScreenCentered,BRTranslate("Please wait"))
            If CreateGadgetList(WindowID())
              TextGadget(500, 4, 5, 190, 20,BRTranslate("Loading file..."),#PB_Text_Center)
            EndIf
            While WindowEvent() : Wend
            If FicSync : ReleaseDX8Sound(FicSync) : EndIf
            FicSync = LoadFromFileDX8Sound (FSyncName$)
            CloseWindow(60)
            SetGadgetText(#TNSync,GetFilePart (FSyncName$))
          EndIf
        ;
      EndSelect 
    EndIf
    ;
    ; Decay sounds
    ;
    Delay(10)
    For ct = 0 To 36
      If Notes(ct)\IsPlaying = 2
        If SRMode$=BRTranslate("Release")
          decay = 100000/ReleaseDelay
        Else
          decay = 100000/SustainDelay
        EndIf
        Notes(ct)\TempVolume = (Notes(ct)\TempVolume*Volume/10000)-decay
        If Notes(ct)\TempVolume<10
          StopDX8Sound(Notes(notouche)\Son)
          Notes(ct)\IsPlaying = 0
        Else
          SetVolumeDX8Sound(Notes(ct)\Son,Notes(ct)\TempVolume-10000)
        EndIf
      EndIf
    Next
    ;
    ; Fermeture fentre
    ;
    ;
    If EventID.l = #PB_Event_CloseWindow     
      Quit=1
    EndIf
  Until Quit
  DestroyCursor_(MoveCursor)
  ReleaseDC_(PSDrawing,hdc)
EndIf
;
;- Ecriture prefs
;
If CreatePreferences(#DatasFolder+"\MonPiano.prefs")
  WritePreferenceString ("TPBkColor", Str(TPBkColor))
  WritePreferenceString ("TPRColor", Str(TPRColor)) 
  WritePreferenceString ("TPLHColor", Str(TPLHColor)) 
  WritePreferenceString ("TPDoColor", Str(TPDoColor)) 
  WritePreferenceString ("TPSolColor", Str(TPSolColor)) 
  WritePreferenceString ("TPLVColor", Str(TPLVColor)) 
  WritePreferenceString ("TPNotesColor", Str(TPNotesColor)) 
  WritePreferenceString ("TPSNotesColor", Str(TPSNotesColor)) 

  WritePreferenceString ("ReleaseDelay", Str(ReleaseDelay)) 
  WritePreferenceString ("SustainDelay", Str(SustainDelay)) 

  WritePreferenceString ("ShowCursor", Str(AlwaysShowCursor)) 
  WritePreferenceString ("BPM", Str(MRythm)) 
  WritePreferenceString ("PitchVar", Str(PitchVar)) 

  WritePreferenceString ("SecRuler", Str(SecRuler)) 
  WritePreferenceString ("MsPos", Str(MsPos)) 
  WritePreferenceString ("MsDur", Str(MsDur)) 
  WritePreferenceString ("IncrDepl", Str(IncrDepl)) 
  WritePreferenceString ("MsIncr", Str(MsIncr)) 
  WritePreferenceString ("IncrDeplCtrl", Str(IncrDeplCtrl)) 
  WritePreferenceString ("MsIncrCtrl", Str(MsIncrCtrl)) 
  WritePreferenceString ("Notation", Str(TypeNotation))
  
  WritePreferenceString ("SELanguage", SELanguage) 
  
  For ct = 0 To 36
    WritePreferenceString ("Key"+Str(ct), Str(Notes(ct)\ToucheClavierPC))
  Next

  ClosePreferences()
EndIf
;
If son_charge
  For t=0 To 36
    ReleaseDX8Sound(Notes(t)\son)
  Next t
EndIf
ReleaseDX8Sound(TicSound)
ReleaseDX8Sound(TacSound)
;
End
;
;
;
Procedure Load_Sounds(NomChemin$)
  
  son_charge = 0
  Contenu = FileSize(NomChemin$)
  If Contenu = -1 ;s'il n'y a rien dans le dossier Bank...
    MessageRequester("Rpertoire vide !", "IL N'Y A AUCUN FICHIER WAV DANS VOTRE BANQUE ("+NomChemin$+")",#MB_ICONEXCLAMATION | #PB_MessageRequester_Ok)
  Else
    ;
    ;Initialisation et chargement de chaque son dans le tableau "Notes()\son"
    ;
    For t=0 To 36
      nomson$ =NomChemin$+"son"+Str(t)+".wav"
      If FileSize(nomson$)<1
        nomson$ =NomChemin$+"sound"+Str(t)+".wav"
      EndIf
      If FileSize(nomson$)<1
        MessageRequester(BRTranslate("CAUTION!"), BRTranslate("This folder does not included all the necessary files (")+nomson$+")")
        t = 36
      Else
        ;
        If son_charge : ReleaseDX8Sound(Notes(t)\son) : EndIf
        Notes(t)\son=LoadFromFileDX8Sound (nomson$)
        If Notes(t)\son
          Frequency = Sound_Frequency
          SetGadgetText(#PITCH,"0")
        EndIf
        SetGadgetState(#LoadBar, t*3); ProgressBar charge  100% 
      EndIf
    Next t
    son_charge=1
  EndIf
EndProcedure
;
Procedure DrawPartition (PStart)
  UseImage(#IPART) 
  StartDrawing(ImageOutput())
  DrawingFont(LoadFont(0,"Arial",7,#PB_Font_HighQuality))
  
  Box(0,0,#PLargeur,#PHauteur,TPBkColor)
  ;
  DrawingMode(0)
  ; Traits horizontaux
  For ct = 1 To 19
    If ct = 3 Or ct = 9 Or ct = 15
      LColor = TPSolColor
      Box(0,16+(ct*(#PHauteur-15)/20),#PLargeur,((#PHauteur-15)/20)-1,LColor)
    EndIf
    If ct = 1 Or ct = 7 Or ct = 13 Or ct = 19
      LColor = TPDoColor
    Else
      LColor = TPLHColor
    EndIf
    Line(0,15+(ct*(#PHauteur-15)/20),#PLargeur,0,LColor)
  Next
  ;
  ct = 0
  If SecRuler
    HScale.f = (#PLargeur/10)*Scale
  Else
    HScale.f = (#PLargeur*6/MRythm)*Scale
  EndIf
  Grad.f = HScale/10
  mGrad = 0
  mDGrad = PStart/HScale
  XP = PStart
  ; Traits de la rgle
  While XP<#PLargeur+PStart
    If Int(XP/Grad)<>mGrad
      mGrad = Int(XP/Grad)
      Line(XP-PStart,0,0,#PHauteur,TPLVColor)
      mTDGrad = Int(XP/HScale)
      If mTDGrad <> mDGrad And (XP-PStart>=Int(Grad))
        Line(XP-PStart,0,0,10,TPRColor)
      Else
        Line(XP-PStart,0,0,5,TPRColor)
      EndIf
      mDGrad = mTDGrad
    EndIf
    XP+1
  Wend
  DrawingMode(1)
  FrontColor(Red(TPRColor), Green(TPRColor), Blue(TPRColor))
  mDGrad = PStart/HScale
  XP = PStart
  ; Texte de la rgle
  While XP<#PLargeur+PStart
    XP+1
    mTDGrad = Int(XP/HScale)
    If mTDGrad <> mDGrad And (XP-PStart>=Int(Grad))
      
      Tx.s = Str(mDGrad+1)
      Locate(XP-PStart-Len(tx)*2, 10)
      DrawText(Tx)
    EndIf
    mDGrad = mTDGrad 
  Wend
  ;
  ctnj = 0
  Repeat
    If NotesJouees(ctnj)\Num<>-1
      PosInPixf.f = NotesJouees(ctnj)\StartTime/10000*#PLargeur*Scale
      DurInPixf.f = NotesJouees(ctnj)\Duration /10000*#PLargeur*Scale
      EndOfTime = NotesJouees(ctnj)\StartTime + NotesJouees(ctnj)\Duration
      PosInPix = Round(PosInPixf,0)-PStart
      If PosInPix+DurInPixf>=0 And PosInPix<#PLargeur
        ct = NotesJouees(ctnj)\Num
        NoteNum.f = #PHauteur-13-(ct/2*(#PHauteur-15)/20)
        If NotesJouees(ctnj)\Selected
          DrawingMode(0)
          Box(PosInPix,Round(NoteNum,0) ,Round(DurInPixf,0),6,TPSNotesColor)
        Else
          DrawingMode(4)
          Box(PosInPix,Round(NoteNum,0) ,Round(DurInPixf,0),6,TPNotesColor)
        EndIf
        NotesJouees(ctnj)\ScreenRect\Top = Round(NoteNum,0)
        NotesJouees(ctnj)\ScreenRect\Left = PosInPix
        NotesJouees(ctnj)\ScreenRect\Right = PosInPix+Round(DurInPixf,0)
        NotesJouees(ctnj)\ScreenRect\Bottom = Round(NoteNum,0)+5
      Else
        NotesJouees(ctnj)\ScreenRect\Top = 0
        NotesJouees(ctnj)\ScreenRect\Left = 0
        NotesJouees(ctnj)\ScreenRect\Right = 0
        NotesJouees(ctnj)\ScreenRect\Bottom = 0
      EndIf
    EndIf
    ctnj + 1
  Until NotesJouees(ctnj)\Num=-1
  StopDrawing()
  SetGadgetState(#IPART, UseImage(#IPART))
  If TimeCursor > EndOfTime
    EndOfTime = TimeCursor 
  EndIf
  If NbScrollSteps*100 < EndOfTime
    NbScrollSteps = EndOfTime/100 + 100
    PosSB = GetGadgetState(#SBPart)
    FreeGadget(#SBPart)
    UseWindow(0)
    ScrollBarGadget  (#SBPart, 5, #HPanel+10+#PHauteur+4,#PLargeur+5, 18, 0, NbScrollSteps , 100/Scale)
    SetGadgetState(#SBPart,PosSB)
  EndIf
  If StartGTime > 0 Or PlayNow > 0
    DrawTimeCursor (AlwaysShowCursor)
  Else
    DrawTimeCursor (0)
  EndIf
EndProcedure
;
Procedure DrawTimeCursor(ShowCursor)
  PosInPixf.f = TimeCursor /10000*#PLargeur*Scale
  PosInPix = Round(PosInPixf,0)-(GetGadgetState(#SBPart)*#PLargeur*Scale/100)
  If PosInPix>=0 And PosInPix<#PLargeur
    If TimeCursor > 0
      UseImage(#IPART) 
      StartDrawing(ImageOutput())
      DrawingMode(2)
      Line(PosInPix,0,0,#PHauteur)
      StopDrawing()
      SetGadgetState(#IPART, UseImage(#IPART))
    EndIf
  Else
    If ShowCursor
      SetGadgetState(#SBPart, (Round(PosInPixf,0)-#PLargeur/2)*100/(#PLargeur*Scale))
      DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
    EndIf
  EndIf
EndProcedure
;
Procedure MonPianoCallback(WindowID, Message, wParam, lParam) 
  Result = #PB_ProcessPureBasicEvents 
  ; 
  If Message =  273 And lParam=GadgetID(#SBPart)
    ;Debug "wparam : "+Str(wParam)
    ;Debug "lparam : "+Str(lParam)
    ;Debug "wparam&$FFFF : "+Str(wParam&$FFFF)
    ;Debug "lparam&$FFFF : "+Str(lParam&$FFFF)
    ;Debug "wparam&$FFFF0000 : "+Str(wParam&$FFFF0000)
    ;Debug "lparam&$FFFF0000 : "+Str(lParam&$FFFF0000)
    DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
  EndIf
  ; 
  ProcedureReturn Result 
EndProcedure
;
Procedure Color_ButtonGadget (ID, x, y, w, h,Color,Repaint)
  If Repaint = 0
    ImageID = CreateImage(ID, w, h)
  Else
    ImageID = UseImage(ID)
  EndIf
  StartDrawing(ImageOutput())
    Box(0, 0, w, h, Color)
  StopDrawing()
  If Repaint = 0
    ButtonImageGadget(ID, x, y, w, h,ImageID)
  Else
    SetGadgetState(ID,ImageID)
  EndIf
EndProcedure
;
Procedure Set_Rect (x1,y1,x2,y2, *FRect.Rect)
  If x2<x1
    mx = x1
    x1 = x2
    x2 = mx
  EndIf
  If y2<y1
    my = y1
    y1 = y2
    y2 = my
  EndIf
  If x1<0 : x1 = 0 : EndIf
  If y1<0 : y1 = 0 : EndIf
  GetWindowRect_(PSDrawing ,@SDRect.RECT)
  If x2>SDRect\Right-SDRect\Left-3
    x2 = SDRect\Right-SDRect\Left-3
  EndIf
  If y2>SDRect\Bottom-SDRect\Top-3
    y2 = SDRect\Bottom-SDRect\Top-3
  EndIf
  *FRect\left = x1
  *FRect\Top = y1
  *FRect\Right = x2
  *FRect\Bottom = y2
EndProcedure
;
Procedure Set_DurAndPos ()
  LPos = -1
  LDur = -1
  LVol = -1
  LNote = -1
  ctnj = 0
  While NotesJouees(ctnj)\Num<>-1
    If NotesJouees(ctnj)\Selected
      If NotesJouees(ctnj)\StartTime < LPos Or LPos = -1
        LPos = NotesJouees(ctnj)\StartTime
      EndIf
      If LDur = -1
        LDur = NotesJouees(ctnj)\Duration
      Else
        If LDur <> NotesJouees(ctnj)\Duration
          LDur = -2
        EndIf
      EndIf
      If LVol = -1
        LVol = NotesJouees(ctnj)\Volume
      Else
        If LVol <> NotesJouees(ctnj)\Volume
          LVol = -2
        EndIf
      EndIf
      If LNote = -1
        LNote = NotesJouees(ctnj)\Num
      Else
        If LNote <> NotesJouees(ctnj)\Num
          LNote = -2
        EndIf
      EndIf
    EndIf
    ctnj + 1
  Wend
  If LPos <0
    SetGadgetText(#SPos,"-")
  Else
    If msPos
      SetGadgetText(#SPos,Str(LPos))
    Else
      SetGadgetText(#SPos,Str(LPos*MRythm/60))
    EndIf
  EndIf
  If LDur <0
    SetGadgetText(#SDur,"-")
  Else
    SetGadgetText(#SDur,Str(LDur*MRythm/60))
    If msDur
      SetGadgetText(#SDur,Str(LDur))
    Else
      SetGadgetText(#SDur,Str(LDur*MRythm/60))
    EndIf
  EndIf
  If LVol <0
    SetGadgetText(#SVol,"-")
  Else
    SetGadgetText(#SVol,Str(LVol))
  EndIf
  If LNote<0
    LNote = -1
  EndIf
  SetGadgetState(#CBNote,LNote)
  WindowEvent()
  WindowEvent()
EndProcedure
;
Procedure CopyForUndo (UndoWhat$)
  If LastUndo$ <> UndoWhat$ Or UndoWhat$="Clear"
    LastUndo$ = UndoWhat$
    CopyMemory(@NotesJouees(0)\Num,UndoNotes+(SizeOf(NotesJouees)*#MaxNbNotes*UndoCLevel),SizeOf(NotesJouees)*#MaxNbNotes)
    UndoName(UndoCLevel)=UndoWhat$
    GadgetToolTip(#UndoR,BRTranslate("Undo last action")+" ("+BRTranslate(UndoName(UndoCLevel))+")")
    If MaxUndoUsed < UndoCLevel : MaxUndoUsed = UndoCLevel : EndIf
    UndoCLevel + 1
    If UndoCLevel = #MaxUndo : UndoCLevel = 0 : EndIf
  EndIf
EndProcedure
;
Procedure UndoTip()
  LastLevel = UndoCLevel - 1
  If LastLevel < 0 : LastLevel = #MaxUndo-1 : EndIf
  If LastLevel <= MaxUndoUsed
    GadgetToolTip(#UndoR,BRTranslate("Undo last action")+" ("+BRTranslate(UndoName(LastLevel))+")")
  Else
    GadgetToolTip(#UndoR,BRTranslate("Undo last action"))
  EndIf
EndProcedure
;
Procedure UndoMP()
  LastLevel = UndoCLevel - 1
  CopyForUndo ("Undo")
  If LastLevel < 0 : LastLevel = #MaxUndo-1 : EndIf
  If LastLevel <= MaxUndoUsed 
    UndoCLevel = LastLevel 
    CopyMemory(UndoNotes+(SizeOf(NotesJouees)*#MaxNbNotes*UndoCLevel),@NotesJouees(0)\Num, SizeOf(NotesJouees)*(#MaxNbNotes))
    DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
    UndoTip()
  EndIf
EndProcedure
;
Procedure RedoTip()
  LastLevel = UndoCLevel + 1
  If LastLevel = #MaxUndo : LastLevel = 0 : EndIf
  If LastLevel <= MaxUndoUsed
    GadgetToolTip(#UndoR,BRTranslate("Redo last action")+" ("+BRTranslate(UndoName(LastLevel))+")")
  Else
    GadgetToolTip(#UndoR,BRTranslate("Redo last action"))
  EndIf
EndProcedure
;
Procedure RedoMP()
  LastLevel = UndoCLevel + 1
  If LastLevel = #MaxUndo : LastLevel = 0 : EndIf
  If LastLevel <= MaxUndoUsed
    UndoCLevel = LastLevel 
    CopyMemory(UndoNotes+(SizeOf(NotesJouees)*#MaxNbNotes*UndoCLevel),@NotesJouees(0)\Num, SizeOf(NotesJouees)*(#MaxNbNotes))
    DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
    RedoTip()
  EndIf
EndProcedure
;
Procedure ClearSelection() 
  CopyForUndo ("Clear")
  ctnj = 0
  While NotesJouees(ctnj)\Num<>-1 : ctnj + 1 : Wend
  lctnj = ctnj
  If lctnj > 0
    ctnj = 0
    While NotesJouees(ctnj)\Num<>-1
      If NotesJouees(ctnj)\Selected
        CopyMemory(@NotesJouees(ctnj+1)\Num,@NotesJouees(ctnj)\Num,SizeOf(NotesJouees)*(lctnj-ctnj))
      Else
        ctnj + 1
      EndIf
    Wend
    DrawPartition (GetGadgetState(#SBPart)*#PLargeur*Scale/100)
    Set_DurAndPos ()
  EndIf
EndProcedure
;
Procedure DefiniNotation()
  If GetGadgetState(#OGDoReMi)
    TypeNotation = 1
  ElseIf GetGadgetState(#OGCDE)
    TypeNotation = 2
  Else
    TypeNotation = 3
  EndIf
  ClearGadgetItemList(#CBNote)
  Restore Notes
  For ct = 0 To 36
    Read NomAnglais$
    Read Nom$
    Read NomAllemand$
    If TypeNotation = 1
      Notes(ct)\Nom = Nom$
    ElseIf TypeNotation = 2
      Notes(ct)\Nom = NomAnglais$
    Else
      Notes(ct)\Nom = NomAllemand$
    EndIf
    Read Couleur$
    Read TouchePC$
    Read TouchePCeng$
    Read TouchePCDeu$
    AddGadgetItem(#CBNote,-1,Notes(ct)\Nom)
  Next
  Set_DurAndPos ()
EndProcedure
;
Procedure.s GiveAscFromVirtual (VKCode)
  If VKCode = #PB_Shortcut_Space
    KText$ = "Sp"
  ElseIf VKCode = #PB_Shortcut_Return
    KText$ = "Ret"
  ElseIf VKCode = #VK_SHIFT
    KText$ = "Sh"
  Else
    KText$ = Chr(MapVirtualKey_(VKCode,2))
  EndIf
  ProcedureReturn KText$
EndProcedure
;
Procedure GiveVirtualFromStr(TouchePC$)
  If TouchePC$="Sp"
    KeyCode = #PB_Shortcut_Space
  ElseIf TouchePC$="Ret"
    KeyCode = #PB_Shortcut_Return
  ElseIf Left(TouchePC$,1)="#"
    KeyCode = Val(Right(TouchePC$,Len(TouchePC$)-1))
  Else
    KeyCode = Asc(TouchePC$)
  EndIf
  ProcedureReturn KeyCode
EndProcedure
;
Procedure StopPausePlay()
  StartGTime = -2
  PlayNow = -1
  For ct = 0 To 36
    If Notes(ct)\IsPlaying = 1
      If Notes(ct)\CouleurTouche = "B"
        CImage = ToucheB;touche blanche
      Else
        CImage = ToucheN;touche noire
      EndIf
      SetGadgetState(ct+200,CImage)
      Notes(ct)\IsPlaying = 2
      Notes(ct)\MustPlay = 0
    EndIf
  Next
  If FicSync
    StopDX8Sound (FicSync)
  EndIf
EndProcedure
;
Procedure StopPlay ()
  DrawTimeCursor(0) ; pour l'effacer
  TimeCursor = 0
  StopPausePlay()
EndProcedure
;
Procedure PutTextsOnButtons ()
  
  GadgetToolTip(#RecordR,BRTranslate("Record a song"))
  GadgetToolTip(#PlayR,BRTranslate("Play the song"))
  GadgetToolTip(#PlayLoopR,BRTranslate("Play loop the song"))
  GadgetToolTip(#PauseR,BRTranslate("Pause playing"))
  GadgetToolTip(#StopR,BRTranslate("Stop playing"))
  GadgetToolTip(#DeleteR,BRTranslate("Clear the song"))
  GadgetToolTip(#StartR,BRTranslate("Go to start of the song"))
  GadgetToolTip(#EndR,BRTranslate("Go to end of the song"))
  GadgetToolTip(#OpenR,BRTranslate("Open a Midi file"))
  GadgetToolTip(#SaveR,BRTranslate("Save the song as Midi or Wave"))
  GadgetToolTip(#ZoomPlusR,BRTranslate("Zoom +"))
  GadgetToolTip(#ZoomMinusR,BRTranslate("Zoom -"))
  GadgetToolTip(#CopyR,BRTranslate("Copy selected notes"))
  GadgetToolTip(#CutR,BRTranslate("Cut selected notes"))
  GadgetToolTip(#PasteR,BRTranslate("Paste notes from clipboard"))
  GadgetToolTip(#ClearR,BRTranslate("Clear selected notes"))
  GadgetToolTip(#UndoR,BRTranslate("Undo last action"))
  GadgetToolTip(#QuantizeR,BRTranslate("Quantize"))
  ;
  SetGadgetText(#SyncFrame,BRTranslate("Synchronised file"))
  SetGadgetText(#BOSync,BRTranslate("Open"))
  SetGadgetText(#MetronomeFrame,BRTranslate("Metronome"))
  SetGadgetText(#MetroOnOff,BRTranslate("Run"))
  SetGadgetText(#MetroRythm,BRTranslate("Rythm"))
  SetGadgetText(#BPM,BRTranslate("BPM"))
  SetGadgetText(#TNote,BRTranslate("Note"))
  SetGadgetText(#TPos,BRTranslate("Position"))
  SetGadgetText(#TDur,BRTranslate("Duration"))
  SetGadgetText(#TVol,BRTranslate("Volume"))
  ;
  SetGadgetItemText(#PanelGadget,0,BRTranslate("SYNTH KEYBOARD"),0)
  SetGadgetItemText(#PanelGadget,1,BRTranslate("Get new sounds"),0)
  SetGadgetItemText(#PanelGadget,2,BRTranslate("Help"),0)
  SetGadgetItemText(#PanelGadget,3,BRTranslate("Preferences"),0)
  SetGadgetItemText(#PanelGadget,4,BRTranslate("Keyboard and language"),0)
  SetGadgetItemText(#PanelGadget,5,BRTranslate("Conception and developpement"),0)
  ;
  SetGadgetText(#LoadFrame,BRTranslate("Load Sounds"))
  GadgetToolTip(#CBankChoice,BRTranslate("Load a new sounds bank"))
  SetGadgetText(#TPITCH,BRTranslate("Pitch"))
  GadgetToolTip(#PITCH,BRTranslate("Mouse wheel"))
  SetGadgetText(#TSRMode,BRTranslate("Mode"))
  SetGadgetText(#SRMode,SRMode$)
  GadgetToolTip(#SRMode,BRTranslate("Lock/Unlock Shift"))
  SetGadgetText(#ControlFrame,BRTranslate("Volumes"))
  SetGadgetText(#TVolBar,BRTranslate("Piano"))
  SetGadgetText(#TVolMBar,BRTranslate("Metronome"))
  SetGadgetText(#TVolFSBar,BRTranslate("Synchronised file"))
  SetGadgetText(#TBalBar,BRTranslate("Balance"))
  ;
  SetGadgetText(#BankFrame,BRTranslate("Sounds banks: how to get them?"))
  SetGadgetText(#Text_Acces,BRTranslate(txgetSounds$))
  SetGadgetText(#HelpFrame,BRTranslate("Help"))
  ClearGadgetItemList(#LIHChoice)
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Play and record your song"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Play and record simultaneously"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Edit your song"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Change the pitch"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Sustain and release"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Save your song"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Multi-instruments song"))
  AddGadgetItem(#LIHChoice,-1, BRTranslate("Reserved keys"))
  SetGadgetState(#LIHChoice,0)
  SetGadgetText(#Text_Info,BRTranslate(txhelp1$))
  ;
  SetGadgetText(#PrefFrame,BRTranslate("Partition"))
  SetGadgetText(#TPBkColor,BRTranslate("Backround color"))
  SetGadgetText(#TPRColor,BRTranslate("Ruler color"))
  SetGadgetText(#TPLHColor,BRTranslate("Horizontal lines color"))
  SetGadgetText(#TPDoColor,BRTranslate("C line color"))
  SetGadgetText(#TPSolColor,BRTranslate("G line color"))
  SetGadgetText(#TPLVColor,BRTranslate("Vertical lines color"))
  SetGadgetText(#TPNotesColor,BRTranslate("Notes color"))
  SetGadgetText(#TPSNotesColor,BRTranslate("Selected notes color"))
  ;
  SetGadgetText(#PrefDecay,BRTranslate("Sustain / Release"))
  SetGadgetText(#TDecaySustain,BRTranslate("Delay - Sustain:"))
  SetGadgetText(#TMsDecaySustain,BRTranslate("ms"))
  SetGadgetText(#TDecayRelease,BRTranslate("Delay - Release:"))
  SetGadgetText(#TMsDecayRelease,BRTranslate("ms"))
  ;
  SetGadgetText(#PrefDivers,BRTranslate("Miscellaneous"))
  SetGadgetText(#ShowCursor,BRTranslate("Always show cursor"))
  SetGadgetText(#TPitchValue,BRTranslate("Pitch variations:"))
  ;
  SetGadgetText(#PrefUnit,BRTranslate("Units"))
  SetGadgetText(#TRuler,BRTranslate("Ruler unit:"))
  SetGadgetText(#OGRulerSec,BRTranslate("Seconde"))
  SetGadgetText(#OGRulerMes,BRTranslate("Metronome rythm"))
  ;
  SetGadgetText(#TPosDisplay,BRTranslate("Position unit:"))
  SetGadgetText(#OGPosms,BRTranslate("ms"))
  SetGadgetText(#OGPosMes,BRTranslate("1/1000th rythm"))
  ;
  SetGadgetText(#TDurDisplay,BRTranslate("Duration:"))
  SetGadgetText(#OGDurms,BRTranslate("ms"))
  SetGadgetText(#OGDurMes,BRTranslate("1/1000th rythm"))
  ;
  SetGadgetText(#TArrowsMoving,BRTranslate("<- and -> keys:"))
  SetGadgetText(#OGArrms,BRTranslate("ms"))
  SetGadgetText(#OGArrMes,BRTranslate("1/1000th rythm"))
  ;
  SetGadgetText(#TArrowsCtrlMoving,BRTranslate("with Ctrl:"))
  SetGadgetText(#OGCtrlms,BRTranslate("ms"))
  SetGadgetText(#OGCtrlMes,BRTranslate("1/1000th rythm"))
  ;
  SetGadgetText(#TLanguage,BRTranslate("Language:"))
  SetGadgetText(#BLanguage,BRTranslate("Add/Modify"))
  SetGadgetText(#TNotation,BRTranslate("Notation:"))
  SetGadgetText(#OGDoReMi,BRTranslate("French (Do, Re, Mi...)"))
  SetGadgetText(#OGCDE,BRTranslate("English (A, B, C...)"))
  SetGadgetText(#OGABH,BRTranslate("German (A, B, H...)"))
  ;
  SetGadgetText(#TKeyboard,BRTranslate("Keyboard keys:"))
  ;
  SetGadgetText(#THKeyboard,BRTranslate("Clic on a note with your mouse, then press the key that must match with this note."))
  ;
  SetGadgetText(#ProjectFrame,"MonPiano "+#TVersion+"  -  "+BRTranslate("Created with PureBasic v3.91"))
  SetGadgetText(#Text_concept,Chr(13)+BRTranslate("- Jacobus: initial programmer 09/2004")+Chr(13)+BRTranslate("- Dobro: programmer and code cleaner.")+Chr(13)+BRTranslate("- ZapMan: programmer and code cleaner - DirectX8 integration, Midi file encoder/decoder, sequencer, language manager.")+Chr(13)+BRTranslate("- Le Soldat Inconnu : smart icons.")+Chr(13)+BRTranslate("- Want to add your name here?? Contact us!")+Chr(13)+Chr(13)+BRTranslate("Have you got the last version of MonPiano? Check it at: "))
  ;
EndProcedure
;
Procedure MakeFourCC (StrValue$)
  CopyMemory(@StrValue$,@BinValue.l,4)
  ProcedureReturn BinValue
EndProcedure
;
Procedure.s FourCCToString (BinValue)
  StrValue$ = Space(4)
  CopyMemory(@BinValue,@StrValue$,4)
  ProcedureReturn StrValue$
EndProcedure
;
Procedure Resample (*soundS,*Infos,SoundLength,NewnSamplesPerSec)
; by Zapman
  *WaveInfo.WAVEFORMATEX = *Infos
  wBitsPerSample.w  = *WaveInfo\wBitsPerSample
  nChannels.w       = *WaveInfo\nChannels
  nBlockAlign       = nChannels*wBitsPerSample/8 
  ;
  ratio.f=NewnSamplesPerSec /*WaveInfo\nSamplesPerSec
  NewSoundLength=SoundLength*ratio
  NewSoundLength=NewSoundLength/nBlockAlign ; to round NewSoundLength to a multiple of nBlockAlign
  NewSoundLength=NewSoundLength*nBlockAlign

  *SoundD=AllocateMemory(NewSoundLength)

  StartS.l = *soundS
  StartD.l = *soundD
  Index.l = 0
  EndS.l = *soundS+SoundLength-nBlockAlign
  EndD.l = *soundD+NewSoundLength-nBlockAlign
  PosD   = 0
  While PosD<EndD And ratio<>0
    pp=Int(Index/ratio)
    Rest.f = (Index/ratio)-pp
    pp=pp*nBlockAlign
    PosSLast=StartS + pp
    PosSNext=PosSLast+nBlockAlign
    PosD=StartD + (Index*nBlockAlign)
    For ct=0 To (nChannels-1)
      Select wBitsPerSample
        Case 8
          DataSLast=PeekB(PosSLast+ct)
          If DataSLast<0  
            DataSLast + 256 ; signed to unsigned
          EndIf
          DataSLast=DataSLast-127 ; 8bits wave signal is from 0 To 256 with a midpoint at 127
          DataSNext=PeekB(PosSNext+ct)
          If DataSNext<0  
            DataSNext+ 256 ; signed to unsigned
          EndIf
          DataSNext=DataSNext-127 ; 8bits wave signal is from 0 To 256 with a midpoint at 127
        Case 16
          DataSLast=PeekW(PosSLast+(ct*2))
          DataSNext=PeekW(PosSNext+(ct*2))
        Case 32
          DataSLast=PeekL(PosSLast+(ct*4))
          DataSNext=PeekL(PosSNext+(ct*4))
      EndSelect 
      DataF.f=(DataSLast*(1-Rest)*(1-Rest))+(DataSNext*Rest*Rest)
      DataF / ((Rest*Rest)+((1-Rest)*(1-Rest)))
      DataD=Round(DataF,0)
      Select wBitsPerSample
        Case 8
          Datab.b = DataD+127
          PokeB(PosD+ct,Datab)
        Case 16
          Dataw.w = DataD
          PokeW(PosD+(ct*2),Dataw)
        Case 32
          PokeL(PosD+(ct*4),DataD)
      EndSelect
    Next 
    Index + 1
  Wend
  FreeMemory(*soundS)
  *WaveInfo\nSamplesPerSec = NewnSamplesPerSec
  *WaveInfo\nAvgBytesPerSec = *WaveInfo\nChannels**WaveInfo\wBitsPerSample/8**WaveInfo\nSamplesPerSec
  ProcedureReturn *soundD
EndProcedure
;
Procedure ReChannel (*soundS,*Infos,SoundLength,NewnChannels.w)
; by Zapman
  *WaveInfo.WAVEFORMATEX = *Infos
  wBitsPerSample.w  = *WaveInfo\wBitsPerSample
  nChannels.w       = *WaveInfo\nChannels
  nBlockAlign       = nChannels*wBitsPerSample/8 
  ;
  NewSoundLength=SoundLength*NewnChannels/nChannels
  NewSoundLength=NewSoundLength/nBlockAlign ; to round NewSoundLength to a multiple of nBlockAlign
  NewSoundLength=NewSoundLength*nBlockAlign
  *SoundD=AllocateMemory(NewSoundLength)
  NewnBlockAlign=NewnChannels*wBitsPerSample/8
  ;
  PosS.l = *soundS
  PosD.l = *soundD
  EndS.l = *soundS+SoundLength-nBlockAlign 
  EndD.l = *soundD+NewSoundLength-NewnBlockAlign
  ratio.f=1/(NewnChannels+1)
  While PosD<EndD
    DataA.f = 0 ; Average - Moyenne
    If NewnChannels<nChannels
      sct=NewnChannels
    Else
      sct = 0
    EndIf 
    For ct=sct To (nChannels-1)
      Select wBitsPerSample
        Case 8
          DataS=PeekB(PosS+ct)
          If DataS<0  
            DataS + 256 ; signed to unsigned
          EndIf
          DataS=DataS-127 ; 8bits wave signal is from 0 To 256 with a midpoint at 127
        Case 16
          DataS=PeekW(PosS+(ct*2))
        Case 32
          DataS=PeekL(PosS+(ct*4))
      EndSelect
      DataA + DataS
    Next
    DataA/(nChannels-sct)
    For ct=0 To (NewnChannels-1)
      If (ct+1)<=nChannels
        Select wBitsPerSample
          Case 8
            DataS=PeekB(PosS+ct)
            If DataS<0  
              DataS + 256 ; signed to unsigned
            EndIf
            DataS=DataS-127 ; 8bits wave signal is from 0 To 256 with a midpoint at 127
          Case 16
            DataS=PeekW(PosS+(ct*2))
          Case 32
            DataS=PeekL(PosS+(ct*4))
        EndSelect
        If NewnChannels<nChannels
          DataA=Round(DataA*ratio,0)
          DataS=Round(DataS*(1-ratio),0)
          DataD=DataA+DataS
        Else
          DataD=DataS 
        EndIf
      Else
        DataD=DataA
      EndIf 
      Select wBitsPerSample
        Case 8
          Datab.b = DataD+127
          PokeB(PosD+ct,Datab)
        Case 16
          Dataw.w = DataD
          PokeW(PosD+(ct*2),Dataw)
        Case 32
          PokeL(PosD+(ct*4),DataD)
      EndSelect
    Next 
    PosS + nBlockAlign
    PosD + NewnBlockAlign
  Wend
  FreeMemory(*soundS)
  *WaveInfo\nChannels = NewnChannels
  *WaveInfo\nBlockAlign = NewnBlockAlign
  *WaveInfo\nAvgBytesPerSec = *WaveInfo\nChannels**WaveInfo\wBitsPerSample/8**WaveInfo\nSamplesPerSec
  ProcedureReturn *soundD
EndProcedure 
;
Procedure SaveAsWave (Result$)
;
  nSamplesPerSec = 44100
  wBitsPerSample = 16
  nChannels      = 2
  nBlockAlign    = wBitsPerSample/8*nChannels
  ;
  Structure WaveHeader
    sFileType.l
    FileSize.l
    sFormat1.l
    sFormat2.l
    ChunckLength.l
    FormatDes.WAVEFORMAT
    wBitsPerSample.w
    sdata.l
    DataSize.l
  EndStructure
  ;
  EndTime = 0
  ctnj = 0
  While NotesJouees(ctnj)\Num<>-1
    If (NotesJouees(ctnj)\StartTime+NotesJouees(ctnj)\Duration)>EndTime
      EndTime = NotesJouees(ctnj)\StartTime+NotesJouees(ctnj)\Duration
    EndIf
    ctnj + 1
  Wend
  ;
  If SRMode$=BRTranslate("Release")
    decay.f = ReleaseDelay
  Else
    decay = SustainDelay
  EndIf
  ;
  If EndTime
    EndTime+decay
  EndIf
  ;
  *FmtChunck = 0
  DEndNote = decay*nSamplesPerSec/1000*nBlockAlign
  DataSize = (EndTime*nSamplesPerSec)/1000*nBlockAlign
  If FindString(Result$,"S",0) And FSyncName$
    ;FSyncName$
  EndIf
  If DataSize
    SNF$ = SaveFileRequester("","" , BRTranslate("Wave file")+"|*.wav",0)
    While WindowEvent() : Wend
    If SNF$
      If LCase(Right(SNF$,4))<>".wav"
        SNF$ + ".wav"
      EndIf
      *spointer.WaveHeader = AllocateMemory(44+DataSize+20)
      If *spointer
        *spointer\sFileType                 = MakeFourCC("RIFF")
        *spointer\FileSize                  = 44                ;Total size, so because the sound is empty, it's the header size
        *spointer\sFormat1                  = MakeFourCC("WAVE")
        *spointer\sFormat2                  = MakeFourCC("fmt ")
        *spointer\ChunckLength              = 16                ;Length of the format chunck
        *spointer\FormatDes\wFormatTag      = #WAVE_FORMAT_PCM  ;the value of #WAVE_FORMAT_PCM is 1, if you want to know               
        *spointer\FormatDes\nChannels       = nChannels
        *spointer\FormatDes\nSamplesPerSec  = nSamplesPerSec
        *spointer\FormatDes\nAvgBytesPerSec = nChannels*wBitsPerSample/8*nSamplesPerSec  ;calculate the average bytes per second = nChannels*wBitsPerSample/8*nSamplesPerSec
        *spointer\FormatDes\nBlockAlign     = nBlockAlign
        *spointer\wBitsPerSample            = wBitsPerSample
        *spointer\sdata                     = MakeFourCC("data")
        *spointer\DataSize                  = DataSize
        RtlZeroMemory_(*spointer+44,DataSize+20)
        NomChemin$ = #DatasFolder+"\BANKS\"+GetGadgetText(#CBankChoice)+"\"
        ctnj = 0
        While NotesJouees(ctnj)\Num<>-1
          ct = NotesJouees(ctnj)\Num
          nomson$ =NomChemin$+"son"+Str(ct)+".wav"
          hmmio = mmioOpen_(nomson$, 0, #MMIO_READ | #MMIO_ALLOCBUF)
          If hmmio = 0
            MessageRequester("Error",BRTranslate("Error #")+Str(mmr)+" "+BRTranslate("While opening")+" "+nomson$,0)
          Else
            cont = 1
            While cont
              If mmioDescend_(hmmio,@ChunkInfo.MMCKINFO, 0, 0)
                cont = 0
              Else
                If FourCCToString(ChunkInfo\fccType)=""
                  If FourCCToString(ChunkInfo\ckID)="fmt "
                    *FmtChunck=AllocateMemory(ChunkInfo\cksize)
                    mmioRead_(hmmio,*FmtChunck,ChunkInfo\cksize) ; Copy the Format chunck at the adress pointed by *FmtChunck
                    *WaveInfo.WAVEFORMATEX = *FmtChunck 
                  ElseIf FourCCToString(ChunkInfo\ckID)="data"
                    *sdata=AllocateMemory(ChunkInfo\cksize)
                    mmioRead_(hmmio,*sdata,ChunkInfo\cksize)
                    If *WaveInfo\nSamplesPerSec <> nSamplesPerSec
                      ratio.f=nSamplesPerSec/*WaveInfo\nSamplesPerSec
                      NewSoundLength=ChunkInfo\cksize*ratio
                      NewSoundLength=NewSoundLength/nBlockAlign ; to round NewSoundLength to a multiple of nBlockAlign
                      NewSoundLength=NewSoundLength*nBlockAlign
                      *sdata= Resample(*sdata,*WaveInfo,ChunkInfo\cksize,nSamplesPerSec)
                      ChunkInfo\cksize = NewSoundLength
                    EndIf
                    If *WaveInfo\nChannels <> nChannels
                      oldCh = *WaveInfo\nChannels
                      NewSoundLength=SoundLength*nChannels/*WaveInfo\nChannels
                      NewSoundLength=NewSoundLength/nBlockAlign ; to round NewSoundLength to a multiple of nBlockAlign
                      NewSoundLength=NewSoundLength*nBlockAlign
                      *sdata= ReChannel(*sdata,*WaveInfo,ChunkInfo\cksize,nChannels)
                      ChunkInfo\cksize = NewSoundLength
                    EndIf
                    StartNote = NotesJouees(ctnj)\StartTime*nSamplesPerSec/1000*nBlockAlign
                    EndNote   = NotesJouees(ctnj)\Duration *nSamplesPerSec/1000*nBlockAlign
                    NVolume.f  = NotesJouees(ctnj)\Volume*Volume/10000
                    VStep.f = 3500000/(decay*nSamplesPerSec)
                    For ct = 0 To EndNote+DEndNote-2 Step 2
                      If ct < ChunkInfo\cksize-2
                        adr1 = *spointer+44+StartNote+ct
                        If *WaveInfo\wBitsPerSample = 16
                          adr2 = *sdata+ct
                          DataNote = PeekW(adr2)
                        ElseIf *WaveInfo\wBitsPerSample = 8
                          adr2 = *sdata+ct/2
                          DataNote = PeekB(adr2)
                          If(DataNote <0) : DataNote + 256 : EndIf ; Convert signed to unsigned
                          DataNote = (DataNote - 127)*256
                        ElseIf *WaveInfo\wBitsPerSample = 32
                          adr2 = *sdata+ct*2
                          DataNote = PeekL(adr2)/(256*256)
                        EndIf
                        ;
                        If ct>EndNote : NVolume-VStep.f : EndIf
                        VVolume.f  = NVolume*NVolume/10000*NVolume/10000*NVolume/10000
                        VVolume  = VVolume*VVolume/10000
                        SSum = PeekW(adr1)+DataNote*VVolume/10000
                        If SSum > $7FFF : SSum = $7FFF : EndIf
                        If SSum < -$7FFF : SSum = -$7FFF : EndIf
                        WSSum.w = SSum
                        PokeW(adr1,WSSum)
                      Else
                        ct = EndNote+DEndNote
                      EndIf
                    Next
                    FreeMemory(*sdata)
                    cont = 1
                  EndIf
                  NextPos = ChunkInfo\dwDataOffset + ChunkInfo\cksize
                  mmioSeek_(hmmio,NextPos,#SEEK_SET)
                EndIf
              EndIf
            Wend
            If *FmtChunck
              FreeMemory(*FmtChunck)
              *FmtChunck = 0
            EndIf
            mmioClose_(hmmio, 0)
          EndIf
          ctnj+1
        Wend
        PlaySound_(*spointer,0,#SND_ASYNC|#SND_MEMORY)
        OpenFile(0,SNF$)
        WriteData(*spointer, DataSize+44)
        CloseFile(0)
        FreeMemory(*spointer)
      Else
        result = 0
      EndIf ; If *spointer
    EndIf ; If SNF$
  Else
    MessageRequester("Ho ho!",BRTranslate("There is nothing to save!"),0)
  EndIf ; If DataSize
  ProcedureReturn(result)
EndProcedure 
;
Procedure SaveWindow(FSyncName$)
  INote.l = CatchImage(200, ?Inote)
  #WLargeur = 244
  #WHauteur = 131
  If OpenWindow(60, 1, 1, #WLargeur ,#WHauteur ,  #PB_Window_TitleBar | #PB_Window_ScreenCentered , BRTranslate("Save"))
    EnableWindow_(MainWindow , #FALSE)
    SetWindowLong_(WindowID(),#GWL_HWNDPARENT,MainWindow)
    If CreateGadgetList(WindowID())
      OptionGadget(#MidiFile, 6, 6, 80, 20, BRTranslate("Midi File"))
      ImageGadget(#INote,10,27,68,65,INote)
      OptionGadget(#WaveFile, 93, 6, 100, 20, BRTranslate("Wave File"))
      CheckBoxGadget(#Instrument, 95, 30, 143, 17, BRTranslate("Include instrument"))
      CheckBoxGadget(#CMetronome, 95, 50, 143, 17, BRTranslate("Include metronome"))
      CheckBoxGadget(#SyncFile, 95, 70, 143, 17, BRTranslate("Include synchronised file"))
      ButtonGadget(#BSave, 153, #WHauteur-30, 83, 22, BRTranslate("Save"),#PB_Button_Default)
      ButtonGadget(#BCancel, 60, #WHauteur-30, 83, 22, BRTranslate("Cancel"))
      SetGadgetState(#MidiFile,1)
      SetGadgetState(#Instrument,1)
      SetGadgetState(#SyncFile,1)
      DisableGadget(#Instrument, 1)
      DisableGadget(#CMetronome, 1)
      DisableGadget(#SyncFile, 1)
      QSave = 0
      BOK = 0
      Repeat
        Event = WaitWindowEvent()
        If Event = #PB_EventGadget
          GadgetID = EventGadgetID()
          ;
          If GadgetID = #MidiFile
            If GetGadgetState(#MidiFile)
              DisableGadget(#Instrument, 1)
              DisableGadget(#CMetronome, 1)
              DisableGadget(#SyncFile, 1)
            EndIf
          ;  
          ElseIf GadgetID = #WaveFile
            If GetGadgetState(#WaveFile)
              DisableGadget(#Instrument, 0)
              DisableGadget(#CMetronome, 0)
              If FSyncName$
                DisableGadget(#SyncFile, 0)
              EndIf
            EndIf
          ;  
          ElseIf GadgetID = #Instrument
          ;  
          ElseIf GadgetID = #CMetronome
          ;  
          ElseIf GadgetID = #SyncFile
          ;  
          ElseIf GadgetID = #BSave
            QSave = 1
            BOK = 1
          ;  
          ElseIf GadgetID = #BCancel
            QSave = 1
          ;  
          EndIf
        ElseIf Event = #PB_EventRepaint
          Lim = 38
          StartDrawing(WindowOutput())
          FrontColor(200,180,180) ; middle gray
          LineXY(0,#WHauteur-Lim ,#WLargeur-0,#WHauteur-Lim )
          LineXY(87,0,87,#WHauteur-Lim )
          FrontColor(245,245,245) ; clear gray
          LineXY(0,#WHauteur-Lim +1,#WLargeur-0,#WHauteur-Lim +1)
          LineXY(88,0,88,#WHauteur-Lim )
          StopDrawing()
        EndIf
        If GetAsyncKeyState_(#VK_ENTER)
          QSave = 1
          BOK = 1
        EndIf
        If GetAsyncKeyState_(#VK_ESCAPE)
          QSave = 1
        EndIf
      Until QSave
      Result$=""
      If BOK
        If GetGadgetState(#Instrument)
          Result$+"I"
        EndIf
        If GetGadgetState(#CMetronome)
          Result$+"M"
        EndIf
        If GetGadgetState(#SyncFile)
          Result$+"S"
        EndIf
        If GetGadgetState(#MidiFile)
          FileType$="Midi"
        Else
          FileType$="Wave"
        EndIf
      EndIf
    EndIf
  EndIf
  FreeImage(200)
  hw = WindowID()
  EnableWindow_(MainWindow, #TRUE)
  SetFocus_(MainWindow)
  DestroyWindow_(hw)
  If BOK
    OpenWindow(60,0,0,200,30,#PB_Window_ScreenCentered,BRTranslate("Please wait"))
    If CreateGadgetList(WindowID())
      TextGadget(500, 4, 5, 190, 20,BRTranslate("Saving file..."),#PB_Text_Center)
    EndIf
    While WindowEvent() : Wend
    If FileType$="Wave"
      SaveAsWave(Result$)
    Else
    
    
    EndIf            
    CloseWindow(60)
  EndIf
EndProcedure



; ExecutableFormat=
; UseIcon=F:\MonPiano\Images\mplogo.ico
; Executable=F:\MonPiano\Mon_Piano.exe
; EOF